/*
 * Copyright 2023 Advanced Micro Devices, Inc.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER(S) OR AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 *
 * Authors: Tom St Denis <tom.stdenis@amd.com>
 *
 */
#include "umr.h"

static const struct umr_mqd_fields  umr_mqd_graphics_gfx12[] = {
	{ 0, "shadow_base_lo" },
	{ 1, "shadow_base_hi" },
	{ 2, "reserved_2" },
	{ 3, "reserved_3" },
	{ 4, "fw_work_area_base_lo" },
	{ 5, "fw_work_area_base_hi" },
	{ 6, "shadow_initialized" },
	{ 7, "ib_vmid" },
	{ 8, "reserved_8" },
	{ 9, "reserved_9" },
	{ 10, "reserved_10" },
	{ 11, "reserved_11" },
	{ 12, "reserved_12" },
	{ 13, "reserved_13" },
	{ 14, "reserved_14" },
	{ 15, "reserved_15" },
	{ 16, "reserved_16" },
	{ 17, "reserved_17" },
	{ 18, "reserved_18" },
	{ 19, "reserved_19" },
	{ 20, "reserved_20" },
	{ 21, "reserved_21" },
	{ 22, "reserved_22" },
	{ 23, "reserved_23" },
	{ 24, "reserved_24" },
	{ 25, "reserved_25" },
	{ 26, "reserved_26" },
	{ 27, "reserved_27" },
	{ 28, "reserved_28" },
	{ 29, "reserved_29" },
	{ 30, "reserved_30" },
	{ 31, "reserved_31" },
	{ 32, "reserved_32" },
	{ 33, "reserved_33" },
	{ 34, "reserved_34" },
	{ 35, "reserved_35" },
	{ 36, "reserved_36" },
	{ 37, "reserved_37" },
	{ 38, "reserved_38" },
	{ 39, "reserved_39" },
	{ 40, "reserved_40" },
	{ 41, "reserved_41" },
	{ 42, "reserved_42" },
	{ 43, "reserved_43" },
	{ 44, "reserved_44" },
	{ 45, "reserved_45" },
	{ 46, "reserved_46" },
	{ 47, "reserved_47" },
	{ 48, "reserved_48" },
	{ 49, "reserved_49" },
	{ 50, "reserved_50" },
	{ 51, "reserved_51" },
	{ 52, "reserved_52" },
	{ 53, "reserved_53" },
	{ 54, "reserved_54" },
	{ 55, "reserved_55" },
	{ 56, "reserved_56" },
	{ 57, "reserved_57" },
	{ 58, "reserved_58" },
	{ 59, "reserved_59" },
	{ 60, "reserved_60" },
	{ 61, "reserved_61" },
	{ 62, "reserved_62" },
	{ 63, "reserved_63" },
	{ 64, "reserved_64" },
	{ 65, "reserved_65" },
	{ 66, "reserved_66" },
	{ 67, "reserved_67" },
	{ 68, "reserved_68" },
	{ 69, "reserved_69" },
	{ 70, "reserved_70" },
	{ 71, "reserved_71" },
	{ 72, "reserved_72" },
	{ 73, "reserved_73" },
	{ 74, "reserved_74" },
	{ 75, "reserved_75" },
	{ 76, "reserved_76" },
	{ 77, "reserved_77" },
	{ 78, "reserved_78" },
	{ 79, "reserved_79" },
	{ 80, "reserved_80" },
	{ 81, "reserved_81" },
	{ 82, "reserved_82" },
	{ 83, "reserved_83" },
	{ 84, "checksum_lo" },
	{ 85, "checksum_hi" },
	{ 86, "cp_mqd_query_time_lo" },
	{ 87, "cp_mqd_query_time_hi" },
	{ 88, "reserved_88" },
	{ 89, "reserved_89" },
	{ 90, "reserved_90" },
	{ 91, "reserved_91" },
	{ 92, "cp_mqd_query_wave_count" },
	{ 93, "cp_mqd_query_gfx_hqd_rptr" },
	{ 94, "cp_mqd_query_gfx_hqd_wptr" },
	{ 95, "cp_mqd_query_gfx_hqd_offset" },
	{ 96, "reserved_96" },
	{ 97, "reserved_97" },
	{ 98, "reserved_98" },
	{ 99, "reserved_99" },
	{ 100, "reserved_100" },
	{ 101, "reserved_101" },
	{ 102, "reserved_102" },
	{ 103, "reserved_103" },
	{ 104, "task_shader_control_buf_addr_lo" },
	{ 105, "task_shader_control_buf_addr_hi" },
	{ 106, "task_shader_read_rptr_lo" },
	{ 107, "task_shader_read_rptr_hi" },
	{ 108, "task_shader_num_entries" },
	{ 109, "task_shader_num_entries_bits" },
	{ 110, "task_shader_ring_buffer_addr_lo" },
	{ 111, "task_shader_ring_buffer_addr_hi" },
	{ 112, "reserved_112" },
	{ 113, "reserved_113" },
	{ 114, "reserved_114" },
	{ 115, "reserved_115" },
	{ 116, "reserved_116" },
	{ 117, "reserved_117" },
	{ 118, "reserved_118" },
	{ 119, "reserved_119" },
	{ 120, "reserved_120" },
	{ 121, "reserved_121" },
	{ 122, "reserved_122" },
	{ 123, "reserved_123" },
	{ 124, "reserved_124" },
	{ 125, "reserved_125" },
	{ 126, "reserved_126" },
	{ 127, "reserved_127" },
	{ 128, "cp_mqd_base_addr" },
	{ 129, "cp_mqd_base_addr_hi" },
	{ 130, "cp_gfx_hqd_active" },
	{ 131, "cp_gfx_hqd_vmid" },
	{ 132, "reserved_132" },
	{ 133, "reserved_133" },
	{ 134, "cp_gfx_hqd_queue_priority" },
	{ 135, "cp_gfx_hqd_quantum" },
	{ 136, "cp_gfx_hqd_base" },
	{ 137, "cp_gfx_hqd_base_hi" },
	{ 138, "cp_gfx_hqd_rptr" },
	{ 139, "cp_gfx_hqd_rptr_addr" },
	{ 140, "cp_gfx_hqd_rptr_addr_hi" },
	{ 141, "cp_rb_wptr_poll_addr_lo" },
	{ 142, "cp_rb_wptr_poll_addr_hi" },
	{ 143, "cp_rb_doorbell_control" },
	{ 144, "cp_gfx_hqd_offset" },
	{ 145, "cp_gfx_hqd_cntl" },
	{ 146, "reserved_146" },
	{ 147, "reserved_147" },
	{ 148, "cp_gfx_hqd_csmd_rptr" },
	{ 149, "cp_gfx_hqd_wptr" },
	{ 150, "cp_gfx_hqd_wptr_hi" },
	{ 151, "reserved_151" },
	{ 152, "reserved_152" },
	{ 153, "reserved_153" },
	{ 154, "reserved_154" },
	{ 155, "reserved_155" },
	{ 156, "cp_gfx_hqd_mapped" },
	{ 157, "cp_gfx_hqd_que_mgr_control" },
	{ 158, "reserved_158" },
	{ 159, "reserved_159" },
	{ 160, "cp_gfx_hqd_hq_status0" },
	{ 161, "cp_gfx_hqd_hq_control0" },
	{ 162, "cp_gfx_mqd_control" },
	{ 163, "reserved_163" },
	{ 164, "reserved_164" },
	{ 165, "reserved_165" },
	{ 166, "reserved_166" },
	{ 167, "reserved_167" },
	{ 168, "reserved_168" },
	{ 169, "reserved_169" },
	{ 170, "reserved_170" },
	{ 171, "reserved_171" },
	{ 172, "reserved_172" },
	{ 173, "reserved_173" },
	{ 174, "reserved_174" },
	{ 175, "reserved_175" },
	{ 176, "reserved_176" },
	{ 177, "reserved_177" },
	{ 178, "reserved_178" },
	{ 179, "reserved_179" },
	{ 180, "reserved_180" },
	{ 181, "reserved_181" },
	{ 182, "reserved_182" },
	{ 183, "reserved_183" },
	{ 184, "reserved_184" },
	{ 185, "reserved_185" },
	{ 186, "reserved_186" },
	{ 187, "reserved_187" },
	{ 188, "reserved_188" },
	{ 189, "reserved_189" },
	{ 190, "reserved_190" },
	{ 191, "reserved_191" },
	{ 192, "reserved_192" },
	{ 193, "reserved_193" },
	{ 194, "reserved_194" },
	{ 195, "reserved_195" },
	{ 196, "reserved_196" },
	{ 197, "reserved_197" },
	{ 198, "reserved_198" },
	{ 199, "reserved_199" },
	{ 200, "reserved_200" },
	{ 201, "reserved_201" },
	{ 202, "reserved_202" },
	{ 203, "reserved_203" },
	{ 204, "reserved_204" },
	{ 205, "reserved_205" },
	{ 206, "reserved_206" },
	{ 207, "reserved_207" },
	{ 208, "reserved_208" },
	{ 209, "reserved_209" },
	{ 210, "reserved_210" },
	{ 211, "reserved_211" },
	{ 212, "reserved_212" },
	{ 213, "reserved_213" },
	{ 214, "reserved_214" },
	{ 215, "reserved_215" },
	{ 216, "reserved_216" },
	{ 217, "reserved_217" },
	{ 218, "reserved_218" },
	{ 219, "reserved_219" },
	{ 220, "reserved_220" },
	{ 221, "reserved_221" },
	{ 222, "reserved_222" },
	{ 223, "reserved_223" },
	{ 224, "reserved_224" },
	{ 225, "reserved_225" },
	{ 226, "reserved_226" },
	{ 227, "reserved_227" },
	{ 228, "reserved_228" },
	{ 229, "reserved_229" },
	{ 230, "reserved_230" },
	{ 231, "reserved_231" },
	{ 232, "reserved_232" },
	{ 233, "reserved_233" },
	{ 234, "reserved_234" },
	{ 235, "reserved_235" },
	{ 236, "reserved_236" },
	{ 237, "reserved_237" },
	{ 238, "reserved_238" },
	{ 239, "reserved_239" },
	{ 240, "reserved_240" },
	{ 241, "reserved_241" },
	{ 242, "reserved_242" },
	{ 243, "reserved_243" },
	{ 244, "reserved_244" },
	{ 245, "reserved_245" },
	{ 246, "reserved_246" },
	{ 247, "reserved_247" },
	{ 248, "reserved_248" },
	{ 249, "reserved_249" },
	{ 250, "reserved_250" },
	{ 251, "reserved_251" },
	{ 252, "reserved_252" },
	{ 253, "reserved_253" },
	{ 254, "reserved_254" },
	{ 255, "reserved_255" },
	{ 256, "reserved_256" },
	{ 257, "reserved_257" },
	{ 258, "reserved_258" },
	{ 259, "reserved_259" },
	{ 260, "reserved_260" },
	{ 261, "reserved_261" },
	{ 262, "reserved_262" },
	{ 263, "reserved_263" },
	{ 264, "reserved_264" },
	{ 265, "reserved_265" },
	{ 266, "reserved_266" },
	{ 267, "reserved_267" },
	{ 268, "reserved_268" },
	{ 269, "reserved_269" },
	{ 270, "reserved_270" },
	{ 271, "reserved_271" },
	{ 272, "dfwx_flags" },
	{ 273, "dfwx_slot" },
	{ 274, "dfwx_client_data_addr_lo" },
	{ 275, "dfwx_client_data_addr_hi" },
	{ 276, "reserved_276" },
	{ 277, "reserved_277" },
	{ 278, "reserved_278" },
	{ 279, "reserved_279" },
	{ 280, "reserved_280" },
	{ 281, "reserved_281" },
	{ 282, "reserved_282" },
	{ 283, "reserved_283" },
	{ 284, "reserved_284" },
	{ 285, "reserved_285" },
	{ 286, "reserved_286" },
	{ 287, "reserved_287" },
	{ 288, "reserved_288" },
	{ 289, "reserved_289" },
	{ 290, "reserved_290" },
	{ 291, "reserved_291" },
	{ 292, "reserved_292" },
	{ 293, "reserved_293" },
	{ 294, "reserved_294" },
	{ 295, "reserved_295" },
	{ 296, "reserved_296" },
	{ 297, "reserved_297" },
	{ 298, "reserved_298" },
	{ 299, "reserved_299" },
	{ 300, "reserved_300" },
	{ 301, "reserved_301" },
	{ 302, "reserved_302" },
	{ 303, "reserved_303" },
	{ 304, "reserved_304" },
	{ 305, "reserved_305" },
	{ 306, "reserved_306" },
	{ 307, "reserved_307" },
	{ 308, "reserved_308" },
	{ 309, "reserved_309" },
	{ 310, "reserved_310" },
	{ 311, "reserved_311" },
	{ 312, "reserved_312" },
	{ 313, "reserved_313" },
	{ 314, "reserved_314" },
	{ 315, "reserved_315" },
	{ 316, "reserved_316" },
	{ 317, "reserved_317" },
	{ 318, "reserved_318" },
	{ 319, "reserved_319" },
	{ 320, "reserved_320" },
	{ 321, "reserved_321" },
	{ 322, "reserved_322" },
	{ 323, "reserved_323" },
	{ 324, "reserved_324" },
	{ 325, "reserved_325" },
	{ 326, "reserved_326" },
	{ 327, "reserved_327" },
	{ 328, "reserved_328" },
	{ 329, "reserved_329" },
	{ 330, "reserved_330" },
	{ 331, "reserved_331" },
	{ 332, "reserved_332" },
	{ 333, "reserved_333" },
	{ 334, "reserved_334" },
	{ 335, "reserved_335" },
	{ 336, "reserved_336" },
	{ 337, "reserved_337" },
	{ 338, "reserved_338" },
	{ 339, "reserved_339" },
	{ 340, "reserved_340" },
	{ 341, "reserved_341" },
	{ 342, "reserved_342" },
	{ 343, "reserved_343" },
	{ 344, "reserved_344" },
	{ 345, "reserved_345" },
	{ 346, "reserved_346" },
	{ 347, "reserved_347" },
	{ 348, "reserved_348" },
	{ 349, "reserved_349" },
	{ 350, "reserved_350" },
	{ 351, "reserved_351" },
	{ 352, "reserved_352" },
	{ 353, "reserved_353" },
	{ 354, "reserved_354" },
	{ 355, "reserved_355" },
	{ 356, "reserved_356" },
	{ 357, "reserved_357" },
	{ 358, "reserved_358" },
	{ 359, "reserved_359" },
	{ 360, "reserved_360" },
	{ 361, "reserved_361" },
	{ 362, "reserved_362" },
	{ 363, "reserved_363" },
	{ 364, "reserved_364" },
	{ 365, "reserved_365" },
	{ 366, "reserved_366" },
	{ 367, "reserved_367" },
	{ 368, "reserved_368" },
	{ 369, "reserved_369" },
	{ 370, "reserved_370" },
	{ 371, "reserved_371" },
	{ 372, "reserved_372" },
	{ 373, "reserved_373" },
	{ 374, "reserved_374" },
	{ 375, "reserved_375" },
	{ 376, "reserved_376" },
	{ 377, "reserved_377" },
	{ 378, "reserved_378" },
	{ 379, "reserved_379" },
	{ 380, "reserved_380" },
	{ 381, "reserved_381" },
	{ 382, "reserved_382" },
	{ 383, "reserved_383" },
	{ 384, "reserved_384" },
	{ 385, "reserved_385" },
	{ 386, "reserved_386" },
	{ 387, "reserved_387" },
	{ 388, "reserved_388" },
	{ 389, "reserved_389" },
	{ 390, "reserved_390" },
	{ 391, "reserved_391" },
	{ 392, "reserved_392" },
	{ 393, "reserved_393" },
	{ 394, "reserved_394" },
	{ 395, "reserved_395" },
	{ 396, "reserved_396" },
	{ 397, "reserved_397" },
	{ 398, "reserved_398" },
	{ 399, "reserved_399" },
	{ 400, "reserved_400" },
	{ 401, "reserved_401" },
	{ 402, "reserved_402" },
	{ 403, "reserved_403" },
	{ 404, "reserved_404" },
	{ 405, "reserved_405" },
	{ 406, "reserved_406" },
	{ 407, "reserved_407" },
	{ 408, "reserved_408" },
	{ 409, "reserved_409" },
	{ 410, "reserved_410" },
	{ 411, "reserved_411" },
	{ 412, "reserved_412" },
	{ 413, "reserved_413" },
	{ 414, "reserved_414" },
	{ 415, "reserved_415" },
	{ 416, "reserved_416" },
	{ 417, "reserved_417" },
	{ 418, "reserved_418" },
	{ 419, "reserved_419" },
	{ 420, "reserved_420" },
	{ 421, "reserved_421" },
	{ 422, "reserved_422" },
	{ 423, "reserved_423" },
	{ 424, "reserved_424" },
	{ 425, "reserved_425" },
	{ 426, "reserved_426" },
	{ 427, "reserved_427" },
	{ 428, "reserved_428" },
	{ 429, "reserved_429" },
	{ 430, "reserved_430" },
	{ 431, "reserved_431" },
	{ 432, "reserved_432" },
	{ 433, "reserved_433" },
	{ 434, "reserved_434" },
	{ 435, "reserved_435" },
	{ 436, "reserved_436" },
	{ 437, "reserved_437" },
	{ 438, "reserved_438" },
	{ 439, "reserved_439" },
	{ 440, "reserved_440" },
	{ 441, "reserved_441" },
	{ 442, "reserved_442" },
	{ 443, "reserved_443" },
	{ 444, "reserved_444" },
	{ 445, "reserved_445" },
	{ 446, "reserved_446" },
	{ 447, "reserved_447" },
	{ 448, "reserved_448" },
	{ 449, "reserved_449" },
	{ 450, "reserved_450" },
	{ 451, "reserved_451" },
	{ 452, "reserved_452" },
	{ 453, "reserved_453" },
	{ 454, "reserved_454" },
	{ 455, "reserved_455" },
	{ 456, "reserved_456" },
	{ 457, "reserved_457" },
	{ 458, "reserved_458" },
	{ 459, "reserved_459" },
	{ 460, "reserved_460" },
	{ 461, "reserved_461" },
	{ 462, "reserved_462" },
	{ 463, "reserved_463" },
	{ 464, "reserved_464" },
	{ 465, "reserved_465" },
	{ 466, "reserved_466" },
	{ 467, "reserved_467" },
	{ 468, "reserved_468" },
	{ 469, "reserved_469" },
	{ 470, "reserved_470" },
	{ 471, "reserved_471" },
	{ 472, "reserved_472" },
	{ 473, "reserved_473" },
	{ 474, "reserved_474" },
	{ 475, "reserved_475" },
	{ 476, "reserved_476" },
	{ 477, "reserved_477" },
	{ 478, "reserved_478" },
	{ 479, "reserved_479" },
	{ 480, "reserved_480" },
	{ 481, "reserved_481" },
	{ 482, "reserved_482" },
	{ 483, "reserved_483" },
	{ 484, "reserved_484" },
	{ 485, "reserved_485" },
	{ 486, "reserved_486" },
	{ 487, "reserved_487" },
	{ 488, "reserved_488" },
	{ 489, "reserved_489" },
	{ 490, "reserved_490" },
	{ 491, "reserved_491" },
	{ 492, "reserved_492" },
	{ 493, "reserved_493" },
	{ 494, "reserved_494" },
	{ 495, "reserved_495" },
	{ 496, "reserved_496" },
	{ 497, "reserved_497" },
	{ 498, "reserved_498" },
	{ 499, "reserved_499" },
	{ 500, "reserved_500" },
	{ 501, "reserved_501" },
	{ 502, "reserved_502" },
	{ 503, "reserved_503" },
	{ 504, "reserved_504" },
	{ 505, "reserved_505" },
	{ 506, "reserved_506" },
	{ 507, "reserved_507" },
	{ 508, "reserved_508" },
	{ 509, "reserved_509" },
	{ 510, "reserved_510" },
	{ 511, "reserved_511" },
};

static const struct umr_mqd_fields  umr_mqd_sdma_gfx12[] = {
	{ 0, "sdmax_rlcx_rb_cntl" },
	{ 1, "sdmax_rlcx_rb_base" },
	{ 2, "sdmax_rlcx_rb_base_hi" },
	{ 3, "sdmax_rlcx_rb_rptr" },
	{ 4, "sdmax_rlcx_rb_rptr_hi" },
	{ 5, "sdmax_rlcx_rb_wptr" },
	{ 6, "sdmax_rlcx_rb_wptr_hi" },
	{ 7, "sdmax_rlcx_rb_rptr_addr_lo" },
	{ 8, "sdmax_rlcx_rb_rptr_addr_hi" },
	{ 9, "sdmax_rlcx_ib_cntl" },
	{ 10, "sdmax_rlcx_ib_rptr" },
	{ 11, "sdmax_rlcx_ib_offset" },
	{ 12, "sdmax_rlcx_ib_base_lo" },
	{ 13, "sdmax_rlcx_ib_base_hi" },
	{ 14, "sdmax_rlcx_ib_size" },
	{ 15, "sdmax_rlcx_doorbell" },
	{ 16, "sdmax_rlcx_doorbell_log" },
	{ 17, "sdmax_rlcx_doorbell_offset" },
	{ 18, "sdmax_rlcx_csa_addr_lo" },
	{ 19, "sdmax_rlcx_csa_addr_hi" },
	{ 20, "sdmax_rlcx_sched_cntl" },
	{ 21, "sdmax_rlcx_ib_sub_remain" },
	{ 22, "sdmax_rlcx_preempt" },
	{ 23, "sdmax_rlcx_dummy_reg" },
	{ 24, "sdmax_rlcx_rb_wptr_poll_addr_lo" },
	{ 25, "sdmax_rlcx_rb_wptr_poll_addr_hi" },
	{ 26, "sdmax_rlcx_rb_aql_cntl" },
	{ 27, "sdmax_rlcx_minor_ptr_update" },
	{ 28, "sdmax_rlcx_mcu_dbg0" },
	{ 29, "sdmax_rlcx_mcu_dbg1" },
	{ 30, "sdmax_rlcx_context_switch_status" },
	{ 31, "sdmax_rlcx_midcmd_cntl" },
	{ 32, "sdmax_rlcx_midcmd_data0" },
	{ 33, "sdmax_rlcx_midcmd_data1" },
	{ 34, "sdmax_rlcx_midcmd_data2" },
	{ 35, "sdmax_rlcx_midcmd_data3" },
	{ 36, "sdmax_rlcx_midcmd_data4" },
	{ 37, "sdmax_rlcx_midcmd_data5" },
	{ 38, "sdmax_rlcx_midcmd_data6" },
	{ 39, "sdmax_rlcx_midcmd_data7" },
	{ 40, "sdmax_rlcx_midcmd_data8" },
	{ 41, "sdmax_rlcx_midcmd_data9" },
	{ 42, "sdmax_rlcx_midcmd_data10" },
	{ 43, "sdmax_rlcx_wait_unsatisfied_thd" },
	{ 44, "sdmax_rlcx_mqd_base_addr_lo" },
	{ 45, "sdmax_rlcx_mqd_base_addr_hi" },
	{ 46, "sdmax_rlcx_mqd_control" },
	{ 47, "reserved_47" },
	{ 48, "reserved_48" },
	{ 49, "reserved_49" },
	{ 50, "reserved_50" },
	{ 51, "reserved_51" },
	{ 52, "reserved_52" },
	{ 53, "reserved_53" },
	{ 54, "reserved_54" },
	{ 55, "reserved_55" },
	{ 56, "reserved_56" },
	{ 57, "reserved_57" },
	{ 58, "reserved_58" },
	{ 59, "reserved_59" },
	{ 60, "reserved_60" },
	{ 61, "reserved_61" },
	{ 62, "reserved_62" },
	{ 63, "reserved_63" },
	{ 64, "reserved_64" },
	{ 65, "reserved_65" },
	{ 66, "reserved_66" },
	{ 67, "reserved_67" },
	{ 68, "reserved_68" },
	{ 69, "reserved_69" },
	{ 70, "reserved_70" },
	{ 0, "reserved_71" },
	{ 1, "reserved_72" },
	{ 2, "reserved_73" },
	{ 3, "reserved_74" },
	{ 4, "reserved_75" },
	{ 5, "reserved_76" },
	{ 6, "reserved_77" },
	{ 7, "reserved_78" },
	{ 79, "reserved_79" },
	{ 80, "reserved_80" },
	{ 81, "reserved_81" },
	{ 82, "reserved_82" },
	{ 83, "reserved_83" },
	{ 84, "reserved_84" },
	{ 85, "reserved_85" },
	{ 86, "reserved_86" },
	{ 87, "reserved_87" },
	{ 88, "reserved_88" },
	{ 89, "reserved_89" },
	{ 90, "reserved_90" },
	{ 91, "reserved_91" },
	{ 92, "reserved_92" },
	{ 93, "reserved_93" },
	{ 94, "reserved_94" },
	{ 95, "reserved_95" },
	{ 96, "reserved_96" },
	{ 97, "reserved_97" },
	{ 98, "reserved_98" },
	{ 99, "reserved_99" },
	{ 100, "reserved_100" },
	{ 101, "reserved_101" },
	{ 102, "reserved_102" },
	{ 103, "reserved_103" },
	{ 104, "reserved_104" },
	{ 105, "reserved_105" },
	{ 106, "reserved_106" },
	{ 107, "reserved_107" },
	{ 108, "reserved_108" },
	{ 109, "reserved_109" },
	{ 110, "reserved_110" },
	{ 111, "reserved_111" },
	{ 112, "reserved_112" },
	{ 113, "reserved_113" },
	{ 114, "reserved_114" },
	{ 115, "reserved_115" },
	{ 116, "reserved_116" },
	{ 117, "reserved_117" },
	{ 118, "reserved_118" },
	{ 119, "reserved_119" },
	{ 120, "reserved_120" },
	{ 121, "reserved_121" },
	{ 122, "reserved_122" },
	{ 123, "reserved_123" },
	{ 124, "reserved_124" },
	{ 125, "reserved_125" },
	{ 126, "sdma_engine_id" },
	{ 127, "sdma_queue_id" },
};

static const struct umr_mqd_fields  umr_mqd_compute_gfx12 [] = {
	{ 0, "header" },
	{ 1, "compute_dispatch_initiator" },
	{ 2, "compute_dim_x" },
	{ 3, "compute_dim_y" },
	{ 4, "compute_dim_z" },
	{ 5, "compute_start_x" },
	{ 6, "compute_start_y" },
	{ 7, "compute_start_z" },
	{ 8, "compute_num_thread_x" },
	{ 9, "compute_num_thread_y" },
	{ 10, "compute_num_thread_z" },
	{ 11, "compute_pipelinestat_enable" },
	{ 12, "compute_perfcount_enable" },
	{ 13, "compute_pgm_lo" },
	{ 14, "compute_pgm_hi" },
	{ 15, "compute_dispatch_pkt_addr_lo" },
	{ 16, "compute_dispatch_pkt_addr_hi" },
	{ 17, "compute_dispatch_scratch_base_lo" },
	{ 18, "compute_dispatch_scratch_base_hi" },
	{ 19, "compute_pgm_rsrc1" },
	{ 20, "compute_pgm_rsrc2" },
	{ 21, "compute_vmid" },
	{ 22, "compute_resource_limits" },
	{ 23, "compute_static_thread_mgmt_se0" },
	{ 24, "compute_static_thread_mgmt_se1" },
	{ 25, "compute_tmpring_size" },
	{ 26, "compute_static_thread_mgmt_se2" },
	{ 27, "compute_static_thread_mgmt_se3" },
	{ 28, "compute_restart_x" },
	{ 29, "compute_restart_y" },
	{ 30, "compute_restart_z" },
	{ 31, "compute_thread_trace_enable" },
	{ 32, "compute_misc_reserved" },
	{ 33, "compute_dispatch_id" },
	{ 34, "compute_threadgroup_id" },
	{ 35, "compute_req_ctrl" },
	{ 36, "reserved_36" },
	{ 37, "compute_user_accum_0" },
	{ 38, "compute_user_accum_1" },
	{ 39, "compute_user_accum_2" },
	{ 40, "compute_user_accum_3" },
	{ 41, "compute_pgm_rsrc3" },
	{ 42, "compute_ddid_index" },
	{ 43, "compute_shader_chksum" },
	{ 44, "compute_static_thread_mgmt_se4" },
	{ 45, "compute_static_thread_mgmt_se5" },
	{ 46, "compute_static_thread_mgmt_se6" },
	{ 47, "compute_static_thread_mgmt_se7" },
	{ 48, "compute_dispatch_interleave" },
	{ 49, "compute_relaunch" },
	{ 50, "compute_wave_restore_addr_lo" },
	{ 51, "compute_wave_restore_addr_hi" },
	{ 52, "compute_wave_restore_control" },
	{ 53, "reserved_53" },
	{ 54, "reserved_54" },
	{ 55, "reserved_55" },
	{ 56, "reserved_56" },
	{ 57, "reserved_57" },
	{ 58, "reserved_58" },
	{ 59, "compute_static_thread_mgmt_se8" },
	{ 60, "reserved_60" },
	{ 61, "reserved_61" },
	{ 62, "reserved_62" },
	{ 63, "reserved_63" },
	{ 64, "reserved_64" },
	{ 65, "compute_user_data_0" },
	{ 66, "compute_user_data_1" },
	{ 67, "compute_user_data_2" },
	{ 68, "compute_user_data_3" },
	{ 69, "compute_user_data_4" },
	{ 70, "compute_user_data_5" },
	{ 71, "compute_user_data_6" },
	{ 72, "compute_user_data_7" },
	{ 73, "compute_user_data_8" },
	{ 74, "compute_user_data_9" },
	{ 75, "compute_user_data_10" },
	{ 76, "compute_user_data_11" },
	{ 77, "compute_user_data_12" },
	{ 78, "compute_user_data_13" },
	{ 79, "compute_user_data_14" },
	{ 80, "compute_user_data_15" },
	{ 81, "cp_compute_csinvoc_count_lo" },
	{ 82, "cp_compute_csinvoc_count_hi" },
	{ 83, "reserved_83" },
	{ 84, "reserved_84" },
	{ 85, "reserved_85" },
	{ 86, "cp_mqd_query_time_lo" },
	{ 87, "cp_mqd_query_time_hi" },
	{ 88, "cp_mqd_connect_start_time_lo" },
	{ 89, "cp_mqd_connect_start_time_hi" },
	{ 90, "cp_mqd_connect_end_time_lo" },
	{ 91, "cp_mqd_connect_end_time_hi" },
	{ 92, "cp_mqd_connect_end_wf_count" },
	{ 93, "cp_mqd_connect_end_pq_rptr" },
	{ 94, "cp_mqd_connect_end_pq_wptr" },
	{ 95, "cp_mqd_connect_end_ib_rptr" },
	{ 96, "cp_mqd_readindex_lo" },
	{ 97, "cp_mqd_readindex_hi" },
	{ 98, "cp_mqd_save_start_time_lo" },
	{ 99, "cp_mqd_save_start_time_hi" },
	{ 100, "cp_mqd_save_end_time_lo" },
	{ 101, "cp_mqd_save_end_time_hi" },
	{ 102, "cp_mqd_restore_start_time_lo" },
	{ 103, "cp_mqd_restore_start_time_hi" },
	{ 104, "cp_mqd_restore_end_time_lo" },
	{ 105, "cp_mqd_restore_end_time_hi" },
	{ 106, "disable_queue" },
	{ 107, "reserved_107" },
	{ 108, "reserved_108" },
	{ 109, "reserved_109" },
	{ 110, "reserved_110" },
	{ 111, "reserved_111" },
	{ 112, "reserved_112" },
	{ 113, "reserved_113" },
	{ 114, "cp_pq_exe_status_lo" },
	{ 115, "cp_pq_exe_status_hi" },
	{ 116, "cp_packet_id_lo" },
	{ 117, "cp_packet_id_hi" },
	{ 118, "cp_packet_exe_status_lo" },
	{ 119, "cp_packet_exe_status_hi" },
	{ 120, "reserved_120" },
	{ 121, "reserved_121" },
	{ 122, "reserved_122" },
	{ 123, "reserved_123" },
	{ 124, "ctx_save_base_addr_lo" },
	{ 125, "ctx_save_base_addr_hi" },
	{ 126, "reserved_126" },
	{ 127, "reserved_127" },
	{ 128, "cp_mqd_base_addr_lo" },
	{ 129, "cp_mqd_base_addr_hi" },
	{ 130, "cp_hqd_active" },
	{ 131, "cp_hqd_vmid" },
	{ 132, "cp_hqd_persistent_state" },
	{ 133, "cp_hqd_pipe_priority" },
	{ 134, "cp_hqd_queue_priority" },
	{ 135, "cp_hqd_quantum" },
	{ 136, "cp_hqd_pq_base_lo" },
	{ 137, "cp_hqd_pq_base_hi" },
	{ 138, "cp_hqd_pq_rptr" },
	{ 139, "cp_hqd_pq_rptr_report_addr_lo" },
	{ 140, "cp_hqd_pq_rptr_report_addr_hi" },
	{ 141, "cp_hqd_pq_wptr_poll_addr_lo" },
	{ 142, "cp_hqd_pq_wptr_poll_addr_hi" },
	{ 143, "cp_hqd_pq_doorbell_control" },
	{ 144, "reserved_144" },
	{ 145, "cp_hqd_pq_control" },
	{ 146, "cp_hqd_ib_base_addr_lo" },
	{ 147, "cp_hqd_ib_base_addr_hi" },
	{ 148, "cp_hqd_ib_rptr" },
	{ 149, "cp_hqd_ib_control" },
	{ 150, "cp_hqd_iq_timer" },
	{ 151, "cp_hqd_iq_rptr" },
	{ 152, "cp_hqd_dequeue_request" },
	{ 153, "cp_hqd_dma_offload" },
	{ 154, "cp_hqd_sema_cmd" },
	{ 155, "cp_hqd_msg_type" },
	{ 156, "cp_hqd_atomic0_preop_lo" },
	{ 157, "cp_hqd_atomic0_preop_hi" },
	{ 158, "cp_hqd_atomic1_preop_lo" },
	{ 159, "cp_hqd_atomic1_preop_hi" },
	{ 160, "cp_hqd_hq_status0" },
	{ 161, "cp_hqd_hq_control0" },
	{ 162, "cp_mqd_control" },
	{ 163, "cp_hqd_hq_status1" },
	{ 164, "cp_hqd_hq_control1" },
	{ 165, "cp_hqd_eop_base_addr_lo" },
	{ 166, "cp_hqd_eop_base_addr_hi" },
	{ 167, "cp_hqd_eop_control" },
	{ 168, "cp_hqd_eop_rptr" },
	{ 169, "cp_hqd_eop_wptr" },
	{ 170, "cp_hqd_eop_done_events" },
	{ 171, "cp_hqd_ctx_save_base_addr_lo" },
	{ 172, "cp_hqd_ctx_save_base_addr_hi" },
	{ 173, "cp_hqd_ctx_save_control" },
	{ 174, "cp_hqd_cntl_stack_offset" },
	{ 175, "cp_hqd_cntl_stack_size" },
	{ 176, "cp_hqd_wg_state_offset" },
	{ 177, "cp_hqd_ctx_save_size" },
	{ 178, "reserved_178" },
	{ 179, "cp_hqd_error" },
	{ 180, "cp_hqd_eop_wptr_mem" },
	{ 181, "cp_hqd_aql_control" },
	{ 182, "cp_hqd_pq_wptr_lo" },
	{ 183, "cp_hqd_pq_wptr_hi" },
	{ 184, "reserved_184" },
	{ 185, "reserved_185" },
	{ 186, "reserved_186" },
	{ 187, "reserved_187" },
	{ 188, "reserved_188" },
	{ 189, "reserved_189" },
	{ 190, "reserved_190" },
	{ 191, "reserved_191" },
	{ 192, "iqtimer_pkt_header" },
	{ 193, "iqtimer_pkt_dw0" },
	{ 194, "iqtimer_pkt_dw1" },
	{ 195, "iqtimer_pkt_dw2" },
	{ 196, "iqtimer_pkt_dw3" },
	{ 197, "iqtimer_pkt_dw4" },
	{ 198, "iqtimer_pkt_dw5" },
	{ 199, "iqtimer_pkt_dw6" },
	{ 200, "iqtimer_pkt_dw7" },
	{ 201, "iqtimer_pkt_dw8" },
	{ 202, "iqtimer_pkt_dw9" },
	{ 203, "iqtimer_pkt_dw10" },
	{ 204, "iqtimer_pkt_dw11" },
	{ 205, "iqtimer_pkt_dw12" },
	{ 206, "iqtimer_pkt_dw13" },
	{ 207, "iqtimer_pkt_dw14" },
	{ 208, "iqtimer_pkt_dw15" },
	{ 209, "iqtimer_pkt_dw16" },
	{ 210, "iqtimer_pkt_dw17" },
	{ 211, "iqtimer_pkt_dw18" },
	{ 212, "iqtimer_pkt_dw19" },
	{ 213, "iqtimer_pkt_dw20" },
	{ 214, "iqtimer_pkt_dw21" },
	{ 215, "iqtimer_pkt_dw22" },
	{ 216, "iqtimer_pkt_dw23" },
	{ 217, "iqtimer_pkt_dw24" },
	{ 218, "iqtimer_pkt_dw25" },
	{ 219, "iqtimer_pkt_dw26" },
	{ 220, "iqtimer_pkt_dw27" },
	{ 221, "iqtimer_pkt_dw28" },
	{ 222, "iqtimer_pkt_dw29" },
	{ 223, "iqtimer_pkt_dw30" },
	{ 224, "iqtimer_pkt_dw31" },
	{ 225, "reserved_225" },
	{ 226, "reserved_226" },
	{ 227, "reserved_227" },
	{ 228, "set_resources_header" },
	{ 229, "set_resources_dw1" },
	{ 230, "set_resources_dw2" },
	{ 231, "set_resources_dw3" },
	{ 232, "set_resources_dw4" },
	{ 233, "set_resources_dw5" },
	{ 234, "set_resources_dw6" },
	{ 235, "set_resources_dw7" },
	{ 236, "reserved_236" },
	{ 237, "reserved_237" },
	{ 238, "reserved_238" },
	{ 239, "reserved_239" },
	{ 240, "queue_doorbell_id0" },
	{ 241, "queue_doorbell_id1" },
	{ 242, "queue_doorbell_id2" },
	{ 243, "queue_doorbell_id3" },
	{ 244, "queue_doorbell_id4" },
	{ 245, "queue_doorbell_id5" },
	{ 246, "queue_doorbell_id6" },
	{ 247, "queue_doorbell_id7" },
	{ 248, "queue_doorbell_id8" },
	{ 249, "queue_doorbell_id9" },
	{ 250, "queue_doorbell_id10" },
	{ 251, "queue_doorbell_id11" },
	{ 252, "queue_doorbell_id12" },
	{ 253, "queue_doorbell_id13" },
	{ 254, "queue_doorbell_id14" },
	{ 255, "queue_doorbell_id15" },
	{ 256, "control_buf_addr_lo" },
	{ 257, "control_buf_addr_hi" },
	{ 258, "control_buf_wptr_lo" },
	{ 259, "control_buf_wptr_hi" },
	{ 260, "control_buf_dptr_lo" },
	{ 261, "control_buf_dptr_hi" },
	{ 262, "control_buf_num_entries" },
	{ 263, "draw_ring_addr_lo" },
	{ 264, "draw_ring_addr_hi" },
	{ 265, "reserved_265" },
	{ 266, "reserved_266" },
	{ 267, "reserved_267" },
	{ 268, "reserved_268" },
	{ 269, "reserved_269" },
	{ 270, "reserved_270" },
	{ 271, "reserved_271" },
	{ 272, "dfwx_flags" },
	{ 273, "dfwx_slot" },
	{ 274, "dfwx_client_data_addr_lo" },
	{ 275, "dfwx_client_data_addr_hi" },
	{ 276, "reserved_276" },
	{ 277, "reserved_277" },
	{ 278, "reserved_278" },
	{ 279, "reserved_279" },
	{ 280, "reserved_280" },
	{ 281, "reserved_281" },
	{ 282, "reserved_282" },
	{ 283, "reserved_283" },
	{ 284, "reserved_284" },
	{ 285, "reserved_285" },
	{ 286, "reserved_286" },
	{ 287, "reserved_287" },
	{ 288, "reserved_288" },
	{ 289, "reserved_289" },
	{ 290, "reserved_290" },
	{ 291, "reserved_291" },
	{ 292, "reserved_292" },
	{ 293, "reserved_293" },
	{ 294, "reserved_294" },
	{ 295, "reserved_295" },
	{ 296, "reserved_296" },
	{ 297, "reserved_297" },
	{ 298, "reserved_298" },
	{ 299, "reserved_299" },
	{ 300, "reserved_300" },
	{ 301, "reserved_301" },
	{ 302, "reserved_302" },
	{ 303, "reserved_303" },
	{ 304, "reserved_304" },
	{ 305, "reserved_305" },
	{ 306, "reserved_306" },
	{ 307, "reserved_307" },
	{ 308, "reserved_308" },
	{ 309, "reserved_309" },
	{ 310, "reserved_310" },
	{ 311, "reserved_311" },
	{ 312, "reserved_312" },
	{ 313, "reserved_313" },
	{ 314, "reserved_314" },
	{ 315, "reserved_315" },
	{ 316, "reserved_316" },
	{ 317, "reserved_317" },
	{ 318, "reserved_318" },
	{ 319, "reserved_319" },
	{ 320, "reserved_320" },
	{ 321, "reserved_321" },
	{ 322, "reserved_322" },
	{ 323, "reserved_323" },
	{ 324, "reserved_324" },
	{ 325, "reserved_325" },
	{ 326, "reserved_326" },
	{ 327, "reserved_327" },
	{ 328, "reserved_328" },
	{ 329, "reserved_329" },
	{ 330, "reserved_330" },
	{ 331, "reserved_331" },
	{ 332, "reserved_332" },
	{ 333, "reserved_333" },
	{ 334, "reserved_334" },
	{ 335, "reserved_335" },
	{ 336, "reserved_336" },
	{ 337, "reserved_337" },
	{ 338, "reserved_338" },
	{ 339, "reserved_339" },
	{ 340, "reserved_340" },
	{ 341, "reserved_341" },
	{ 342, "reserved_342" },
	{ 343, "reserved_343" },
	{ 344, "reserved_344" },
	{ 345, "reserved_345" },
	{ 346, "reserved_346" },
	{ 347, "reserved_347" },
	{ 348, "reserved_348" },
	{ 349, "reserved_349" },
	{ 350, "reserved_350" },
	{ 351, "reserved_351" },
	{ 352, "reserved_352" },
	{ 353, "reserved_353" },
	{ 354, "reserved_354" },
	{ 355, "reserved_355" },
	{ 356, "reserved_356" },
	{ 357, "reserved_357" },
	{ 358, "reserved_358" },
	{ 359, "reserved_359" },
	{ 360, "reserved_360" },
	{ 361, "reserved_361" },
	{ 362, "reserved_362" },
	{ 363, "reserved_363" },
	{ 364, "reserved_364" },
	{ 365, "reserved_365" },
	{ 366, "reserved_366" },
	{ 367, "reserved_367" },
	{ 368, "reserved_368" },
	{ 369, "reserved_369" },
	{ 370, "reserved_370" },
	{ 371, "reserved_371" },
	{ 372, "reserved_372" },
	{ 373, "reserved_373" },
	{ 374, "reserved_374" },
	{ 375, "reserved_375" },
	{ 376, "reserved_376" },
	{ 377, "reserved_377" },
	{ 378, "reserved_378" },
	{ 379, "reserved_379" },
	{ 380, "reserved_380" },
	{ 381, "reserved_381" },
	{ 382, "reserved_382" },
	{ 383, "reserved_383" },
	{ 384, "reserved_384" },
	{ 385, "reserved_385" },
	{ 386, "reserved_386" },
	{ 387, "reserved_387" },
	{ 388, "reserved_388" },
	{ 389, "reserved_389" },
	{ 390, "reserved_390" },
	{ 391, "reserved_391" },
	{ 392, "reserved_392" },
	{ 393, "reserved_393" },
	{ 394, "reserved_394" },
	{ 395, "reserved_395" },
	{ 396, "reserved_396" },
	{ 397, "reserved_397" },
	{ 398, "reserved_398" },
	{ 399, "reserved_399" },
	{ 400, "reserved_400" },
	{ 401, "reserved_401" },
	{ 402, "reserved_402" },
	{ 403, "reserved_403" },
	{ 404, "reserved_404" },
	{ 405, "reserved_405" },
	{ 406, "reserved_406" },
	{ 407, "reserved_407" },
	{ 408, "reserved_408" },
	{ 409, "reserved_409" },
	{ 410, "reserved_410" },
	{ 411, "reserved_411" },
	{ 412, "reserved_412" },
	{ 413, "reserved_413" },
	{ 414, "reserved_414" },
	{ 415, "reserved_415" },
	{ 416, "reserved_416" },
	{ 417, "reserved_417" },
	{ 418, "reserved_418" },
	{ 419, "reserved_419" },
	{ 420, "reserved_420" },
	{ 421, "reserved_421" },
	{ 422, "reserved_422" },
	{ 423, "reserved_423" },
	{ 424, "reserved_424" },
	{ 425, "reserved_425" },
	{ 426, "reserved_426" },
	{ 427, "reserved_427" },
	{ 428, "reserved_428" },
	{ 429, "reserved_429" },
	{ 430, "reserved_430" },
	{ 431, "reserved_431" },
	{ 432, "reserved_432" },
	{ 433, "reserved_433" },
	{ 434, "reserved_434" },
	{ 435, "reserved_435" },
	{ 436, "reserved_436" },
	{ 437, "reserved_437" },
	{ 438, "reserved_438" },
	{ 439, "reserved_439" },
	{ 440, "reserved_440" },
	{ 441, "reserved_441" },
	{ 442, "reserved_442" },
	{ 443, "reserved_443" },
	{ 444, "reserved_444" },
	{ 445, "reserved_445" },
	{ 446, "reserved_446" },
	{ 447, "reserved_447" },
	{ 448, "gws_0_val" },
	{ 449, "gws_1_val" },
	{ 450, "gws_2_val" },
	{ 451, "gws_3_val" },
	{ 452, "gws_4_val" },
	{ 453, "gws_5_val" },
	{ 454, "gws_6_val" },
	{ 455, "gws_7_val" },
	{ 456, "gws_8_val" },
	{ 457, "gws_9_val" },
	{ 458, "gws_10_val" },
	{ 459, "gws_11_val" },
	{ 460, "gws_12_val" },
	{ 461, "gws_13_val" },
	{ 462, "gws_14_val" },
	{ 463, "gws_15_val" },
	{ 464, "gws_16_val" },
	{ 465, "gws_17_val" },
	{ 466, "gws_18_val" },
	{ 467, "gws_19_val" },
	{ 468, "gws_20_val" },
	{ 469, "gws_21_val" },
	{ 470, "gws_22_val" },
	{ 471, "gws_23_val" },
	{ 472, "gws_24_val" },
	{ 473, "gws_25_val" },
	{ 474, "gws_26_val" },
	{ 475, "gws_27_val" },
	{ 476, "gws_28_val" },
	{ 477, "gws_29_val" },
	{ 478, "gws_30_val" },
	{ 479, "gws_31_val" },
	{ 480, "gws_32_val" },
	{ 481, "gws_33_val" },
	{ 482, "gws_34_val" },
	{ 483, "gws_35_val" },
	{ 484, "gws_36_val" },
	{ 485, "gws_37_val" },
	{ 486, "gws_38_val" },
	{ 487, "gws_39_val" },
	{ 488, "gws_40_val" },
	{ 489, "gws_41_val" },
	{ 490, "gws_42_val" },
	{ 491, "gws_43_val" },
	{ 492, "gws_44_val" },
	{ 493, "gws_45_val" },
	{ 494, "gws_46_val" },
	{ 495, "gws_47_val" },
	{ 496, "gws_48_val" },
	{ 497, "gws_49_val" },
	{ 498, "gws_50_val" },
	{ 499, "gws_51_val" },
	{ 500, "gws_52_val" },
	{ 501, "gws_53_val" },
	{ 502, "gws_54_val" },
	{ 503, "gws_55_val" },
	{ 504, "gws_56_val" },
	{ 505, "gws_57_val" },
	{ 506, "gws_58_val" },
	{ 507, "gws_59_val" },
	{ 508, "gws_60_val" },
	{ 509, "gws_61_val" },
	{ 510, "gws_62_val" },
	{ 511, "gws_63_val" },
};

static const struct umr_mqd_fields umr_mqd_compute_gfx11[] = {
		{ 0, "header" },
		{ 1, "compute_dispatch_initiator" },
		{ 2, "compute_dim_x" },
		{ 3, "compute_dim_y" },
		{ 4, "compute_dim_z" },
		{ 5, "compute_start_x" },
		{ 6, "compute_start_y" },
		{ 7, "compute_start_z" },
		{ 8, "compute_num_thread_x" },
		{ 9, "compute_num_thread_y" },
		{ 10, "compute_num_thread_z" },
		{ 11, "compute_pipelinestat_enable" },
		{ 12, "compute_perfcount_enable" },
		{ 13, "compute_pgm_lo" },
		{ 14, "compute_pgm_hi" },
		{ 15, "compute_dispatch_pkt_addr_lo" },
		{ 16, "compute_dispatch_pkt_addr_hi" },
		{ 17, "compute_dispatch_scratch_base_lo" },
		{ 18, "compute_dispatch_scratch_base_hi" },
		{ 19, "compute_pgm_rsrc1" },
		{ 20, "compute_pgm_rsrc2" },
		{ 21, "compute_vmid" },
		{ 22, "compute_resource_limits" },
		{ 23, "compute_static_thread_mgmt_se0" },
		{ 24, "compute_static_thread_mgmt_se1" },
		{ 25, "compute_tmpring_size" },
		{ 26, "compute_static_thread_mgmt_se2" },
		{ 27, "compute_static_thread_mgmt_se3" },
		{ 28, "compute_restart_x" },
		{ 29, "compute_restart_y" },
		{ 30, "compute_restart_z" },
		{ 31, "compute_thread_trace_enable" },
		{ 33, "compute_dispatch_id" },
		{ 34, "compute_threadgroup_id" },
		{ 35, "compute_req_ctrl" },
		{ 37, "compute_user_accum_0" },
		{ 38, "compute_user_accum_1" },
		{ 39, "compute_user_accum_2" },
		{ 40, "compute_user_accum_3" },
		{ 41, "compute_pgm_rsrc3" },
		{ 42, "compute_ddid_index" },
		{ 43, "compute_shader_chksum" },
		{ 44, "compute_relaunch" },
		{ 45, "compute_wave_restore_addr_lo" },
		{ 46, "compute_wave_restore_addr_hi" },
		{ 47, "compute_wave_restore_control" },
		{ 65, "compute_user_data_0" },
		{ 66, "compute_user_data_1" },
		{ 67, "compute_user_data_2" },
		{ 68, "compute_user_data_3" },
		{ 69, "compute_user_data_4" },
		{ 70, "compute_user_data_5" },
		{ 71, "compute_user_data_6" },
		{ 72, "compute_user_data_7" },
		{ 73, "compute_user_data_8" },
		{ 74, "compute_user_data_9" },
		{ 75, "compute_user_data_10" },
		{ 76, "compute_user_data_11" },
		{ 77, "compute_user_data_12" },
		{ 78, "compute_user_data_13" },
		{ 79, "compute_user_data_14" },
		{ 80, "compute_user_data_15" },
		{ 81, "cp_compute_csinvoc_count_lo" },
		{ 82, "cp_compute_csinvoc_count_hi" },
		{ 86, "cp_mqd_query_time_lo" },
		{ 87, "cp_mqd_query_time_hi" },
		{ 88, "cp_mqd_connect_start_time_lo" },
		{ 89, "cp_mqd_connect_start_time_hi" },
		{ 90, "cp_mqd_connect_end_time_lo" },
		{ 91, "cp_mqd_connect_end_time_hi" },
		{ 92, "cp_mqd_connect_end_wf_count" },
		{ 93, "cp_mqd_connect_end_pq_rptr" },
		{ 94, "cp_mqd_connect_end_pq_wptr" },
		{ 95, "cp_mqd_connect_end_ib_rptr" },
		{ 96, "cp_mqd_readindex_lo" },
		{ 97, "cp_mqd_readindex_hi" },
		{ 98, "cp_mqd_save_start_time_lo" },
		{ 99, "cp_mqd_save_start_time_hi" },
		{ 100, "cp_mqd_save_end_time_lo" },
		{ 101, "cp_mqd_save_end_time_hi" },
		{ 102, "cp_mqd_restore_start_time_lo" },
		{ 103, "cp_mqd_restore_start_time_hi" },
		{ 104, "cp_mqd_restore_end_time_lo" },
		{ 105, "cp_mqd_restore_end_time_hi" },
		{ 106, "disable_queue" },
		{ 108, "gds_cs_ctxsw_cnt0" },
		{ 109, "gds_cs_ctxsw_cnt1" },
		{ 110, "gds_cs_ctxsw_cnt2" },
		{ 111, "gds_cs_ctxsw_cnt3" },
		{ 114, "cp_pq_exe_status_lo" },
		{ 115, "cp_pq_exe_status_hi" },
		{ 116, "cp_packet_id_lo" },
		{ 117, "cp_packet_id_hi" },
		{ 118, "cp_packet_exe_status_lo" },
		{ 119, "cp_packet_exe_status_hi" },
		{ 120, "gds_save_base_addr_lo" },
		{ 121, "gds_save_base_addr_hi" },
		{ 122, "gds_save_mask_lo" },
		{ 123, "gds_save_mask_hi" },
		{ 124, "ctx_save_base_addr_lo" },
		{ 125, "ctx_save_base_addr_hi" },
		{ 128, "cp_mqd_base_addr_lo" },
		{ 129, "cp_mqd_base_addr_hi" },
		{ 130, "cp_hqd_active" },
		{ 131, "cp_hqd_vmid" },
		{ 132, "cp_hqd_persistent_state" },
		{ 133, "cp_hqd_pipe_priority" },
		{ 134, "cp_hqd_queue_priority" },
		{ 135, "cp_hqd_quantum" },
		{ 136, "cp_hqd_pq_base_lo" },
		{ 137, "cp_hqd_pq_base_hi" },
		{ 138, "cp_hqd_pq_rptr" },
		{ 139, "cp_hqd_pq_rptr_report_addr_lo" },
		{ 140, "cp_hqd_pq_rptr_report_addr_hi" },
		{ 141, "cp_hqd_pq_wptr_poll_addr_lo" },
		{ 142, "cp_hqd_pq_wptr_poll_addr_hi" },
		{ 143, "cp_hqd_pq_doorbell_control" },
		{ 145, "cp_hqd_pq_control" },
		{ 146, "cp_hqd_ib_base_addr_lo" },
		{ 147, "cp_hqd_ib_base_addr_hi" },
		{ 148, "cp_hqd_ib_rptr" },
		{ 149, "cp_hqd_ib_control" },
		{ 150, "cp_hqd_iq_timer" },
		{ 151, "cp_hqd_iq_rptr" },
		{ 152, "cp_hqd_dequeue_request" },
		{ 153, "cp_hqd_dma_offload" },
		{ 154, "cp_hqd_sema_cmd" },
		{ 155, "cp_hqd_msg_type" },
		{ 156, "cp_hqd_atomic0_preop_lo" },
		{ 157, "cp_hqd_atomic0_preop_hi" },
		{ 158, "cp_hqd_atomic1_preop_lo" },
		{ 159, "cp_hqd_atomic1_preop_hi" },
		{ 160, "cp_hqd_hq_status0" },
		{ 161, "cp_hqd_hq_control0" },
		{ 162, "cp_mqd_control" },
		{ 163, "cp_hqd_hq_status1" },
		{ 164, "cp_hqd_hq_control1" },
		{ 165, "cp_hqd_eop_base_addr_lo" },
		{ 166, "cp_hqd_eop_base_addr_hi" },
		{ 167, "cp_hqd_eop_control" },
		{ 168, "cp_hqd_eop_rptr" },
		{ 169, "cp_hqd_eop_wptr" },
		{ 170, "cp_hqd_eop_done_events" },
		{ 171, "cp_hqd_ctx_save_base_addr_lo" },
		{ 172, "cp_hqd_ctx_save_base_addr_hi" },
		{ 173, "cp_hqd_ctx_save_control" },
		{ 174, "cp_hqd_cntl_stack_offset" },
		{ 175, "cp_hqd_cntl_stack_size" },
		{ 176, "cp_hqd_wg_state_offset" },
		{ 177, "cp_hqd_ctx_save_size" },
		{ 178, "cp_hqd_gds_resource_state" },
		{ 179, "cp_hqd_error" },
		{ 180, "cp_hqd_eop_wptr_mem" },
		{ 181, "cp_hqd_aql_control" },
		{ 182, "cp_hqd_pq_wptr_lo" },
		{ 183, "cp_hqd_pq_wptr_hi" },
		{ 192, "iqtimer_pkt_header" },
		{ 193, "iqtimer_pkt_dw0" },
		{ 194, "iqtimer_pkt_dw1" },
		{ 195, "iqtimer_pkt_dw2" },
		{ 196, "iqtimer_pkt_dw3" },
		{ 197, "iqtimer_pkt_dw4" },
		{ 198, "iqtimer_pkt_dw5" },
		{ 199, "iqtimer_pkt_dw6" },
		{ 200, "iqtimer_pkt_dw7" },
		{ 201, "iqtimer_pkt_dw8" },
		{ 202, "iqtimer_pkt_dw9" },
		{ 203, "iqtimer_pkt_dw10" },
		{ 204, "iqtimer_pkt_dw11" },
		{ 205, "iqtimer_pkt_dw12" },
		{ 206, "iqtimer_pkt_dw13" },
		{ 207, "iqtimer_pkt_dw14" },
		{ 208, "iqtimer_pkt_dw15" },
		{ 209, "iqtimer_pkt_dw16" },
		{ 210, "iqtimer_pkt_dw17" },
		{ 211, "iqtimer_pkt_dw18" },
		{ 212, "iqtimer_pkt_dw19" },
		{ 213, "iqtimer_pkt_dw20" },
		{ 214, "iqtimer_pkt_dw21" },
		{ 215, "iqtimer_pkt_dw22" },
		{ 216, "iqtimer_pkt_dw23" },
		{ 217, "iqtimer_pkt_dw24" },
		{ 218, "iqtimer_pkt_dw25" },
		{ 219, "iqtimer_pkt_dw26" },
		{ 220, "iqtimer_pkt_dw27" },
		{ 221, "iqtimer_pkt_dw28" },
		{ 222, "iqtimer_pkt_dw29" },
		{ 223, "iqtimer_pkt_dw30" },
		{ 224, "iqtimer_pkt_dw31" },
		{ 228, "set_resources_header" },
		{ 229, "set_resources_dw1" },
		{ 230, "set_resources_dw2" },
		{ 231, "set_resources_dw3" },
		{ 232, "set_resources_dw4" },
		{ 233, "set_resources_dw5" },
		{ 234, "set_resources_dw6" },
		{ 235, "set_resources_dw7" },
		{ 240, "queue_doorbell_id0" },
		{ 241, "queue_doorbell_id1" },
		{ 242, "queue_doorbell_id2" },
		{ 243, "queue_doorbell_id3" },
		{ 244, "queue_doorbell_id4" },
		{ 245, "queue_doorbell_id5" },
		{ 246, "queue_doorbell_id6" },
		{ 247, "queue_doorbell_id7" },
		{ 248, "queue_doorbell_id8" },
		{ 249, "queue_doorbell_id9" },
		{ 250, "queue_doorbell_id10" },
		{ 251, "queue_doorbell_id11" },
		{ 252, "queue_doorbell_id12" },
		{ 253, "queue_doorbell_id13" },
		{ 254, "queue_doorbell_id14" },
		{ 255, "queue_doorbell_id15" },
		{ 256, "control_buf_addr_lo" },
		{ 257, "control_buf_addr_hi" },
		{ 258, "control_buf_wptr_lo" },
		{ 259, "control_buf_wptr_hi" },
		{ 260, "control_buf_dptr_lo" },
		{ 261, "control_buf_dptr_hi" },
		{ 262, "control_buf_num_entries" },
		{ 263, "draw_ring_addr_lo" },
		{ 264, "draw_ring_addr_hi" },
		{ 448, "gws_0_val" },
		{ 449, "gws_1_val" },
		{ 450, "gws_2_val" },
		{ 451, "gws_3_val" },
		{ 452, "gws_4_val" },
		{ 453, "gws_5_val" },
		{ 454, "gws_6_val" },
		{ 455, "gws_7_val" },
		{ 456, "gws_8_val" },
		{ 457, "gws_9_val" },
		{ 458, "gws_10_val" },
		{ 459, "gws_11_val" },
		{ 460, "gws_12_val" },
		{ 461, "gws_13_val" },
		{ 462, "gws_14_val" },
		{ 463, "gws_15_val" },
		{ 464, "gws_16_val" },
		{ 465, "gws_17_val" },
		{ 466, "gws_18_val" },
		{ 467, "gws_19_val" },
		{ 468, "gws_20_val" },
		{ 469, "gws_21_val" },
		{ 470, "gws_22_val" },
		{ 471, "gws_23_val" },
		{ 472, "gws_24_val" },
		{ 473, "gws_25_val" },
		{ 474, "gws_26_val" },
		{ 475, "gws_27_val" },
		{ 476, "gws_28_val" },
		{ 477, "gws_29_val" },
		{ 478, "gws_30_val" },
		{ 479, "gws_31_val" },
		{ 480, "gws_32_val" },
		{ 481, "gws_33_val" },
		{ 482, "gws_34_val" },
		{ 483, "gws_35_val" },
		{ 484, "gws_36_val" },
		{ 485, "gws_37_val" },
		{ 486, "gws_38_val" },
		{ 487, "gws_39_val" },
		{ 488, "gws_40_val" },
		{ 489, "gws_41_val" },
		{ 490, "gws_42_val" },
		{ 491, "gws_43_val" },
		{ 492, "gws_44_val" },
		{ 493, "gws_45_val" },
		{ 494, "gws_46_val" },
		{ 495, "gws_47_val" },
		{ 496, "gws_48_val" },
		{ 497, "gws_49_val" },
		{ 498, "gws_50_val" },
		{ 499, "gws_51_val" },
		{ 500, "gws_52_val" },
		{ 501, "gws_53_val" },
		{ 502, "gws_54_val" },
		{ 503, "gws_55_val" },
		{ 504, "gws_56_val" },
		{ 505, "gws_57_val" },
		{ 506, "gws_58_val" },
		{ 507, "gws_59_val" },
		{ 508, "gws_60_val" },
		{ 509, "gws_61_val" },
		{ 510, "gws_62_val" },
		{ 511, "gws_63_val" },
		{ 0, NULL },
};

static const struct umr_mqd_fields umr_mqd_graphics_gfx11[] = {
		{ 84, "checksum_lo" },
		{ 85, "checksum_hi" },
		{ 86, "cp_mqd_query_time_lo" },
		{ 87, "cp_mqd_query_time_hi" },
		{ 92, "cp_mqd_query_wave_count" },
		{ 93, "cp_mqd_query_gfx_hqd_rptr" },
		{ 94, "cp_mqd_query_gfx_hqd_wptr" },
		{ 95, "cp_mqd_query_gfx_hqd_offset" },
		{ 104, "control_buf_addr_lo" },
		{ 105, "control_buf_addr_hi" },
		{ 106, "disable_queue" },
		{ 128, "cp_mqd_base_addr" },
		{ 129, "cp_mqd_base_addr_hi" },
		{ 130, "cp_gfx_hqd_active" },
		{ 131, "cp_gfx_hqd_vmid" },
		{ 134, "cp_gfx_hqd_queue_priority" },
		{ 135, "cp_gfx_hqd_quantum" },
		{ 136, "cp_gfx_hqd_base" },
		{ 137, "cp_gfx_hqd_base_hi" },
		{ 138, "cp_gfx_hqd_rptr" },
		{ 139, "cp_gfx_hqd_rptr_addr" },
		{ 140, "cp_gfx_hqd_rptr_addr_hi" },
		{ 141, "cp_rb_wptr_poll_addr_lo" },
		{ 142, "cp_rb_wptr_poll_addr_hi" },
		{ 143, "cp_rb_doorbell_control" },
		{ 144, "cp_gfx_hqd_offset" },
		{ 145, "cp_gfx_hqd_cntl" },
		{ 148, "cp_gfx_hqd_csmd_rptr" },
		{ 149, "cp_gfx_hqd_wptr" },
		{ 150, "cp_gfx_hqd_wptr_hi" },
		{ 156, "cp_gfx_hqd_mapped" },
		{ 157, "cp_gfx_hqd_que_mgr_control" },
		{ 160, "cp_gfx_hqd_hq_status0" },
		{ 161, "cp_gfx_hqd_hq_control0" },
		{ 162, "cp_gfx_mqd_control" },
		{ 170, "cp_num_prim_needed_count0_lo" },
		{ 171, "cp_num_prim_needed_count0_hi" },
		{ 172, "cp_num_prim_needed_count1_lo" },
		{ 173, "cp_num_prim_needed_count1_hi" },
		{ 174, "cp_num_prim_needed_count2_lo" },
		{ 175, "cp_num_prim_needed_count2_hi" },
		{ 176, "cp_num_prim_needed_count3_lo" },
		{ 177, "cp_num_prim_needed_count3_hi" },
		{ 178, "cp_num_prim_written_count0_lo" },
		{ 179, "cp_num_prim_written_count0_hi" },
		{ 180, "cp_num_prim_written_count1_lo" },
		{ 181, "cp_num_prim_written_count1_hi" },
		{ 182, "cp_num_prim_written_count2_lo" },
		{ 183, "cp_num_prim_written_count2_hi" },
		{ 184, "cp_num_prim_written_count3_lo" },
		{ 185, "cp_num_prim_written_count3_hi" },
		{ 190, "mp1_smn_fps_cnt" },
		{ 191, "sq_thread_trace_buf0_base" },
		{ 192, "sq_thread_trace_buf0_size" },
		{ 193, "sq_thread_trace_buf1_base" },
		{ 194, "sq_thread_trace_buf1_size" },
		{ 195, "sq_thread_trace_wptr" },
		{ 196, "sq_thread_trace_mask" },
		{ 197, "sq_thread_trace_token_mask" },
		{ 198, "sq_thread_trace_ctrl" },
		{ 199, "sq_thread_trace_status" },
		{ 200, "sq_thread_trace_dropped_cntr" },
		{ 201, "sq_thread_trace_finish_done_debug" },
		{ 202, "sq_thread_trace_gfx_draw_cntr" },
		{ 203, "sq_thread_trace_gfx_marker_cntr" },
		{ 204, "sq_thread_trace_hp3d_draw_cntr" },
		{ 205, "sq_thread_trace_hp3d_marker_cntr" },
		{ 208, "cp_sc_psinvoc_count0_lo" },
		{ 209, "cp_sc_psinvoc_count0_hi" },
		{ 210, "cp_pa_cprim_count_lo" },
		{ 211, "cp_pa_cprim_count_hi" },
		{ 212, "cp_pa_cinvoc_count_lo" },
		{ 213, "cp_pa_cinvoc_count_hi" },
		{ 214, "cp_vgt_vsinvoc_count_lo" },
		{ 215, "cp_vgt_vsinvoc_count_hi" },
		{ 216, "cp_vgt_gsinvoc_count_lo" },
		{ 217, "cp_vgt_gsinvoc_count_hi" },
		{ 218, "cp_vgt_gsprim_count_lo" },
		{ 219, "cp_vgt_gsprim_count_hi" },
		{ 220, "cp_vgt_iaprim_count_lo" },
		{ 221, "cp_vgt_iaprim_count_hi" },
		{ 222, "cp_vgt_iavert_count_lo" },
		{ 223, "cp_vgt_iavert_count_hi" },
		{ 224, "cp_vgt_hsinvoc_count_lo" },
		{ 225, "cp_vgt_hsinvoc_count_hi" },
		{ 226, "cp_vgt_dsinvoc_count_lo" },
		{ 227, "cp_vgt_dsinvoc_count_hi" },
		{ 228, "cp_vgt_csinvoc_count_lo" },
		{ 229, "cp_vgt_csinvoc_count_hi" },
		{ 268, "vgt_strmout_buffer_filled_size_0" },
		{ 269, "vgt_strmout_buffer_filled_size_1" },
		{ 270, "vgt_strmout_buffer_filled_size_2" },
		{ 271, "vgt_strmout_buffer_filled_size_3" },
		{ 276, "vgt_dma_max_size" },
		{ 277, "vgt_dma_num_instances" },
		{ 288, "it_set_base_ib_addr_lo" },
		{ 289, "it_set_base_ib_addr_hi" },
		{ 356, "spi_shader_pgm_rsrc3_ps" },
		{ 357, "spi_shader_pgm_rsrc3_vs" },
		{ 358, "spi_shader_pgm_rsrc3_gs" },
		{ 359, "spi_shader_pgm_rsrc3_hs" },
		{ 360, "spi_shader_pgm_rsrc4_ps" },
		{ 361, "spi_shader_pgm_rsrc4_vs" },
		{ 362, "spi_shader_pgm_rsrc4_gs" },
		{ 363, "spi_shader_pgm_rsrc4_hs" },
		{ 364, "db_occlusion_count0_low_00" },
		{ 365, "db_occlusion_count0_hi_00" },
		{ 366, "db_occlusion_count1_low_00" },
		{ 367, "db_occlusion_count1_hi_00" },
		{ 368, "db_occlusion_count2_low_00" },
		{ 369, "db_occlusion_count2_hi_00" },
		{ 370, "db_occlusion_count3_low_00" },
		{ 371, "db_occlusion_count3_hi_00" },
		{ 372, "db_occlusion_count0_low_01" },
		{ 373, "db_occlusion_count0_hi_01" },
		{ 374, "db_occlusion_count1_low_01" },
		{ 375, "db_occlusion_count1_hi_01" },
		{ 376, "db_occlusion_count2_low_01" },
		{ 377, "db_occlusion_count2_hi_01" },
		{ 378, "db_occlusion_count3_low_01" },
		{ 379, "db_occlusion_count3_hi_01" },
		{ 380, "db_occlusion_count0_low_02" },
		{ 381, "db_occlusion_count0_hi_02" },
		{ 382, "db_occlusion_count1_low_02" },
		{ 383, "db_occlusion_count1_hi_02" },
		{ 384, "db_occlusion_count2_low_02" },
		{ 385, "db_occlusion_count2_hi_02" },
		{ 386, "db_occlusion_count3_low_02" },
		{ 387, "db_occlusion_count3_hi_02" },
		{ 388, "db_occlusion_count0_low_03" },
		{ 389, "db_occlusion_count0_hi_03" },
		{ 390, "db_occlusion_count1_low_03" },
		{ 391, "db_occlusion_count1_hi_03" },
		{ 392, "db_occlusion_count2_low_03" },
		{ 393, "db_occlusion_count2_hi_03" },
		{ 394, "db_occlusion_count3_low_03" },
		{ 395, "db_occlusion_count3_hi_03" },
		{ 396, "db_occlusion_count0_low_04" },
		{ 397, "db_occlusion_count0_hi_04" },
		{ 398, "db_occlusion_count1_low_04" },
		{ 399, "db_occlusion_count1_hi_04" },
		{ 400, "db_occlusion_count2_low_04" },
		{ 401, "db_occlusion_count2_hi_04" },
		{ 402, "db_occlusion_count3_low_04" },
		{ 403, "db_occlusion_count3_hi_04" },
		{ 404, "db_occlusion_count0_low_05" },
		{ 405, "db_occlusion_count0_hi_05" },
		{ 406, "db_occlusion_count1_low_05" },
		{ 407, "db_occlusion_count1_hi_05" },
		{ 408, "db_occlusion_count2_low_05" },
		{ 409, "db_occlusion_count2_hi_05" },
		{ 410, "db_occlusion_count3_low_05" },
		{ 411, "db_occlusion_count3_hi_05" },
		{ 412, "db_occlusion_count0_low_06" },
		{ 413, "db_occlusion_count0_hi_06" },
		{ 414, "db_occlusion_count1_low_06" },
		{ 415, "db_occlusion_count1_hi_06" },
		{ 416, "db_occlusion_count2_low_06" },
		{ 417, "db_occlusion_count2_hi_06" },
		{ 418, "db_occlusion_count3_low_06" },
		{ 419, "db_occlusion_count3_hi_06" },
		{ 420, "db_occlusion_count0_low_07" },
		{ 421, "db_occlusion_count0_hi_07" },
		{ 422, "db_occlusion_count1_low_07" },
		{ 423, "db_occlusion_count1_hi_07" },
		{ 424, "db_occlusion_count2_low_07" },
		{ 425, "db_occlusion_count2_hi_07" },
		{ 426, "db_occlusion_count3_low_07" },
		{ 427, "db_occlusion_count3_hi_07" },
		{ 428, "db_occlusion_count0_low_10" },
		{ 429, "db_occlusion_count0_hi_10" },
		{ 430, "db_occlusion_count1_low_10" },
		{ 431, "db_occlusion_count1_hi_10" },
		{ 432, "db_occlusion_count2_low_10" },
		{ 433, "db_occlusion_count2_hi_10" },
		{ 434, "db_occlusion_count3_low_10" },
		{ 435, "db_occlusion_count3_hi_10" },
		{ 436, "db_occlusion_count0_low_11" },
		{ 437, "db_occlusion_count0_hi_11" },
		{ 438, "db_occlusion_count1_low_11" },
		{ 439, "db_occlusion_count1_hi_11" },
		{ 440, "db_occlusion_count2_low_11" },
		{ 441, "db_occlusion_count2_hi_11" },
		{ 442, "db_occlusion_count3_low_11" },
		{ 443, "db_occlusion_count3_hi_11" },
		{ 444, "db_occlusion_count0_low_12" },
		{ 445, "db_occlusion_count0_hi_12" },
		{ 446, "db_occlusion_count1_low_12" },
		{ 447, "db_occlusion_count1_hi_12" },
		{ 448, "db_occlusion_count2_low_12" },
		{ 449, "db_occlusion_count2_hi_12" },
		{ 450, "db_occlusion_count3_low_12" },
		{ 451, "db_occlusion_count3_hi_12" },
		{ 452, "db_occlusion_count0_low_13" },
		{ 453, "db_occlusion_count0_hi_13" },
		{ 454, "db_occlusion_count1_low_13" },
		{ 455, "db_occlusion_count1_hi_13" },
		{ 456, "db_occlusion_count2_low_13" },
		{ 457, "db_occlusion_count2_hi_13" },
		{ 458, "db_occlusion_count3_low_13" },
		{ 459, "db_occlusion_count3_hi_13" },
		{ 460, "db_occlusion_count0_low_14" },
		{ 461, "db_occlusion_count0_hi_14" },
		{ 462, "db_occlusion_count1_low_14" },
		{ 463, "db_occlusion_count1_hi_14" },
		{ 464, "db_occlusion_count2_low_14" },
		{ 465, "db_occlusion_count2_hi_14" },
		{ 466, "db_occlusion_count3_low_14" },
		{ 467, "db_occlusion_count3_hi_14" },
		{ 468, "db_occlusion_count0_low_15" },
		{ 469, "db_occlusion_count0_hi_15" },
		{ 470, "db_occlusion_count1_low_15" },
		{ 471, "db_occlusion_count1_hi_15" },
		{ 472, "db_occlusion_count2_low_15" },
		{ 473, "db_occlusion_count2_hi_15" },
		{ 474, "db_occlusion_count3_low_15" },
		{ 475, "db_occlusion_count3_hi_15" },
		{ 476, "db_occlusion_count0_low_16" },
		{ 477, "db_occlusion_count0_hi_16" },
		{ 478, "db_occlusion_count1_low_16" },
		{ 479, "db_occlusion_count1_hi_16" },
		{ 480, "db_occlusion_count2_low_16" },
		{ 481, "db_occlusion_count2_hi_16" },
		{ 482, "db_occlusion_count3_low_16" },
		{ 483, "db_occlusion_count3_hi_16" },
		{ 484, "db_occlusion_count0_low_17" },
		{ 485, "db_occlusion_count0_hi_17" },
		{ 486, "db_occlusion_count1_low_17" },
		{ 487, "db_occlusion_count1_hi_17" },
		{ 488, "db_occlusion_count2_low_17" },
		{ 489, "db_occlusion_count2_hi_17" },
		{ 490, "db_occlusion_count3_low_17" },
		{ 491, "db_occlusion_count3_hi_17" },
		{ 0, NULL },
};

static const struct umr_mqd_fields umr_mqd_sdma_gfx11[] = {
		{ 0, "sdmax_rlcx_rb_cntl" },
		{ 1, "sdmax_rlcx_rb_base" },
		{ 2, "sdmax_rlcx_rb_base_hi" },
		{ 3, "sdmax_rlcx_rb_rptr" },
		{ 4, "sdmax_rlcx_rb_rptr_hi" },
		{ 5, "sdmax_rlcx_rb_wptr" },
		{ 6, "sdmax_rlcx_rb_wptr_hi" },
		{ 7, "sdmax_rlcx_rb_rptr_addr_hi" },
		{ 8, "sdmax_rlcx_rb_rptr_addr_lo" },
		{ 9, "sdmax_rlcx_ib_cntl" },
		{ 10, "sdmax_rlcx_ib_rptr" },
		{ 11, "sdmax_rlcx_ib_offset" },
		{ 12, "sdmax_rlcx_ib_base_lo" },
		{ 13, "sdmax_rlcx_ib_base_hi" },
		{ 14, "sdmax_rlcx_ib_size" },
		{ 15, "sdmax_rlcx_skip_cntl" },
		{ 16, "sdmax_rlcx_context_status" },
		{ 17, "sdmax_rlcx_doorbell" },
		{ 18, "sdmax_rlcx_doorbell_log" },
		{ 19, "sdmax_rlcx_doorbell_offset" },
		{ 20, "sdmax_rlcx_csa_addr_lo" },
		{ 21, "sdmax_rlcx_csa_addr_hi" },
		{ 22, "sdmax_rlcx_sched_cntl" },
		{ 23, "sdmax_rlcx_ib_sub_remain" },
		{ 24, "sdmax_rlcx_preempt" },
		{ 25, "sdmax_rlcx_dummy_reg" },
		{ 26, "sdmax_rlcx_rb_wptr_poll_addr_hi" },
		{ 27, "sdmax_rlcx_rb_wptr_poll_addr_lo" },
		{ 28, "sdmax_rlcx_rb_aql_cntl" },
		{ 29, "sdmax_rlcx_minor_ptr_update" },
		{ 30, "sdmax_rlcx_rb_preempt" },
		{ 31, "sdmax_rlcx_midcmd_data0" },
		{ 32, "sdmax_rlcx_midcmd_data1" },
		{ 33, "sdmax_rlcx_midcmd_data2" },
		{ 34, "sdmax_rlcx_midcmd_data3" },
		{ 35, "sdmax_rlcx_midcmd_data4" },
		{ 36, "sdmax_rlcx_midcmd_data5" },
		{ 37, "sdmax_rlcx_midcmd_data6" },
		{ 38, "sdmax_rlcx_midcmd_data7" },
		{ 39, "sdmax_rlcx_midcmd_data8" },
		{ 40, "sdmax_rlcx_midcmd_data9" },
		{ 41, "sdmax_rlcx_midcmd_data10" },
		{ 42, "sdmax_rlcx_midcmd_cntl" },
		{ 43, "sdmax_rlcx_f32_dbg0" },
		{ 44, "sdmax_rlcx_f32_dbg1" },
		{ 126, "sdma_engine_id" },
		{ 127, "sdma_queue_id" },
		{ 0, NULL },
};

static const struct umr_mqd_fields umr_mqd_compute_nv[] = {
		{ 0, "header" },
		{ 1, "compute_dispatch_initiator" },
		{ 2, "compute_dim_x" },
		{ 3, "compute_dim_y" },
		{ 4, "compute_dim_z" },
		{ 5, "compute_start_x" },
		{ 6, "compute_start_y" },
		{ 7, "compute_start_z" },
		{ 8, "compute_num_thread_x" },
		{ 9, "compute_num_thread_y" },
		{ 10, "compute_num_thread_z" },
		{ 11, "compute_pipelinestat_enable" },
		{ 12, "compute_perfcount_enable" },
		{ 13, "compute_pgm_lo" },
		{ 14, "compute_pgm_hi" },
		{ 15, "compute_tba_lo" },
		{ 16, "compute_tba_hi" },
		{ 17, "compute_tma_lo" },
		{ 18, "compute_tma_hi" },
		{ 19, "compute_pgm_rsrc1" },
		{ 20, "compute_pgm_rsrc2" },
		{ 21, "compute_vmid" },
		{ 22, "compute_resource_limits" },
		{ 23, "compute_static_thread_mgmt_se0" },
		{ 24, "compute_static_thread_mgmt_se1" },
		{ 25, "compute_tmpring_size" },
		{ 26, "compute_static_thread_mgmt_se2" },
		{ 27, "compute_static_thread_mgmt_se3" },
		{ 28, "compute_restart_x" },
		{ 29, "compute_restart_y" },
		{ 30, "compute_restart_z" },
		{ 31, "compute_thread_trace_enable" },
		{ 33, "compute_dispatch_id" },
		{ 34, "compute_threadgroup_id" },
		{ 35, "compute_relaunch" },
		{ 36, "compute_wave_restore_addr_lo" },
		{ 37, "compute_wave_restore_addr_hi" },
		{ 38, "compute_wave_restore_control" },
		{ 65, "compute_user_data_0" },
		{ 66, "compute_user_data_1" },
		{ 67, "compute_user_data_2" },
		{ 68, "compute_user_data_3" },
		{ 69, "compute_user_data_4" },
		{ 70, "compute_user_data_5" },
		{ 71, "compute_user_data_6" },
		{ 72, "compute_user_data_7" },
		{ 73, "compute_user_data_8" },
		{ 74, "compute_user_data_9" },
		{ 75, "compute_user_data_10" },
		{ 76, "compute_user_data_11" },
		{ 77, "compute_user_data_12" },
		{ 78, "compute_user_data_13" },
		{ 79, "compute_user_data_14" },
		{ 80, "compute_user_data_15" },
		{ 81, "cp_compute_csinvoc_count_lo" },
		{ 82, "cp_compute_csinvoc_count_hi" },
		{ 86, "cp_mqd_query_time_lo" },
		{ 87, "cp_mqd_query_time_hi" },
		{ 88, "cp_mqd_connect_start_time_lo" },
		{ 89, "cp_mqd_connect_start_time_hi" },
		{ 90, "cp_mqd_connect_end_time_lo" },
		{ 91, "cp_mqd_connect_end_time_hi" },
		{ 92, "cp_mqd_connect_end_wf_count" },
		{ 93, "cp_mqd_connect_end_pq_rptr" },
		{ 94, "cp_mqd_connect_end_pq_wptr" },
		{ 95, "cp_mqd_connect_end_ib_rptr" },
		{ 96, "cp_mqd_readindex_lo" },
		{ 97, "cp_mqd_readindex_hi" },
		{ 98, "cp_mqd_save_start_time_lo" },
		{ 99, "cp_mqd_save_start_time_hi" },
		{ 100, "cp_mqd_save_end_time_lo" },
		{ 101, "cp_mqd_save_end_time_hi" },
		{ 102, "cp_mqd_restore_start_time_lo" },
		{ 103, "cp_mqd_restore_start_time_hi" },
		{ 104, "cp_mqd_restore_end_time_lo" },
		{ 105, "cp_mqd_restore_end_time_hi" },
		{ 106, "disable_queue" },
		{ 108, "gds_cs_ctxsw_cnt0" },
		{ 109, "gds_cs_ctxsw_cnt1" },
		{ 110, "gds_cs_ctxsw_cnt2" },
		{ 111, "gds_cs_ctxsw_cnt3" },
		{ 114, "cp_pq_exe_status_lo" },
		{ 115, "cp_pq_exe_status_hi" },
		{ 116, "cp_packet_id_lo" },
		{ 117, "cp_packet_id_hi" },
		{ 118, "cp_packet_exe_status_lo" },
		{ 119, "cp_packet_exe_status_hi" },
		{ 120, "gds_save_base_addr_lo" },
		{ 121, "gds_save_base_addr_hi" },
		{ 122, "gds_save_mask_lo" },
		{ 123, "gds_save_mask_hi" },
		{ 124, "ctx_save_base_addr_lo" },
		{ 125, "ctx_save_base_addr_hi" },
		{ 128, "cp_mqd_base_addr_lo" },
		{ 129, "cp_mqd_base_addr_hi" },
		{ 130, "cp_hqd_active" },
		{ 131, "cp_hqd_vmid" },
		{ 132, "cp_hqd_persistent_state" },
		{ 133, "cp_hqd_pipe_priority" },
		{ 134, "cp_hqd_queue_priority" },
		{ 135, "cp_hqd_quantum" },
		{ 136, "cp_hqd_pq_base_lo" },
		{ 137, "cp_hqd_pq_base_hi" },
		{ 138, "cp_hqd_pq_rptr" },
		{ 139, "cp_hqd_pq_rptr_report_addr_lo" },
		{ 140, "cp_hqd_pq_rptr_report_addr_hi" },
		{ 141, "cp_hqd_pq_wptr_poll_addr_lo" },
		{ 142, "cp_hqd_pq_wptr_poll_addr_hi" },
		{ 143, "cp_hqd_pq_doorbell_control" },
		{ 145, "cp_hqd_pq_control" },
		{ 146, "cp_hqd_ib_base_addr_lo" },
		{ 147, "cp_hqd_ib_base_addr_hi" },
		{ 148, "cp_hqd_ib_rptr" },
		{ 149, "cp_hqd_ib_control" },
		{ 150, "cp_hqd_iq_timer" },
		{ 151, "cp_hqd_iq_rptr" },
		{ 152, "cp_hqd_dequeue_request" },
		{ 153, "cp_hqd_dma_offload" },
		{ 154, "cp_hqd_sema_cmd" },
		{ 155, "cp_hqd_msg_type" },
		{ 156, "cp_hqd_atomic0_preop_lo" },
		{ 157, "cp_hqd_atomic0_preop_hi" },
		{ 158, "cp_hqd_atomic1_preop_lo" },
		{ 159, "cp_hqd_atomic1_preop_hi" },
		{ 160, "cp_hqd_hq_scheduler0" },
		{ 161, "cp_hqd_hq_scheduler1" },
		{ 162, "cp_mqd_control" },
		{ 163, "cp_hqd_hq_status1" },
		{ 164, "cp_hqd_hq_control1" },
		{ 165, "cp_hqd_eop_base_addr_lo" },
		{ 166, "cp_hqd_eop_base_addr_hi" },
		{ 167, "cp_hqd_eop_control" },
		{ 168, "cp_hqd_eop_rptr" },
		{ 169, "cp_hqd_eop_wptr" },
		{ 170, "cp_hqd_eop_done_events" },
		{ 171, "cp_hqd_ctx_save_base_addr_lo" },
		{ 172, "cp_hqd_ctx_save_base_addr_hi" },
		{ 173, "cp_hqd_ctx_save_control" },
		{ 174, "cp_hqd_cntl_stack_offset" },
		{ 175, "cp_hqd_cntl_stack_size" },
		{ 176, "cp_hqd_wg_state_offset" },
		{ 177, "cp_hqd_ctx_save_size" },
		{ 178, "cp_hqd_gds_resource_state" },
		{ 179, "cp_hqd_error" },
		{ 180, "cp_hqd_eop_wptr_mem" },
		{ 181, "cp_hqd_aql_control" },
		{ 182, "cp_hqd_pq_wptr_lo" },
		{ 183, "cp_hqd_pq_wptr_hi" },
		{ 184, "cp_hqd_suspend_cntl_stack_offset" },
		{ 185, "cp_hqd_suspend_cntl_stack_dw_cnt" },
		{ 186, "cp_hqd_suspend_wg_state_offset" },
		{ 192, "iqtimer_pkt_header" },
		{ 193, "iqtimer_pkt_dw0" },
		{ 194, "iqtimer_pkt_dw1" },
		{ 195, "iqtimer_pkt_dw2" },
		{ 196, "iqtimer_pkt_dw3" },
		{ 197, "iqtimer_pkt_dw4" },
		{ 198, "iqtimer_pkt_dw5" },
		{ 199, "iqtimer_pkt_dw6" },
		{ 200, "iqtimer_pkt_dw7" },
		{ 201, "iqtimer_pkt_dw8" },
		{ 202, "iqtimer_pkt_dw9" },
		{ 203, "iqtimer_pkt_dw10" },
		{ 204, "iqtimer_pkt_dw11" },
		{ 205, "iqtimer_pkt_dw12" },
		{ 206, "iqtimer_pkt_dw13" },
		{ 207, "iqtimer_pkt_dw14" },
		{ 208, "iqtimer_pkt_dw15" },
		{ 209, "iqtimer_pkt_dw16" },
		{ 210, "iqtimer_pkt_dw17" },
		{ 211, "iqtimer_pkt_dw18" },
		{ 212, "iqtimer_pkt_dw19" },
		{ 213, "iqtimer_pkt_dw20" },
		{ 214, "iqtimer_pkt_dw21" },
		{ 215, "iqtimer_pkt_dw22" },
		{ 216, "iqtimer_pkt_dw23" },
		{ 217, "iqtimer_pkt_dw24" },
		{ 218, "iqtimer_pkt_dw25" },
		{ 219, "iqtimer_pkt_dw26" },
		{ 220, "iqtimer_pkt_dw27" },
		{ 221, "iqtimer_pkt_dw28" },
		{ 222, "iqtimer_pkt_dw29" },
		{ 223, "iqtimer_pkt_dw30" },
		{ 224, "iqtimer_pkt_dw31" },
		{ 228, "set_resources_header" },
		{ 229, "set_resources_dw1" },
		{ 230, "set_resources_dw2" },
		{ 231, "set_resources_dw3" },
		{ 232, "set_resources_dw4" },
		{ 233, "set_resources_dw5" },
		{ 234, "set_resources_dw6" },
		{ 235, "set_resources_dw7" },
		{ 240, "queue_doorbell_id0" },
		{ 241, "queue_doorbell_id1" },
		{ 242, "queue_doorbell_id2" },
		{ 243, "queue_doorbell_id3" },
		{ 244, "queue_doorbell_id4" },
		{ 245, "queue_doorbell_id5" },
		{ 246, "queue_doorbell_id6" },
		{ 247, "queue_doorbell_id7" },
		{ 248, "queue_doorbell_id8" },
		{ 249, "queue_doorbell_id9" },
		{ 250, "queue_doorbell_id10" },
		{ 251, "queue_doorbell_id11" },
		{ 252, "queue_doorbell_id12" },
		{ 253, "queue_doorbell_id13" },
		{ 254, "queue_doorbell_id14" },
		{ 255, "queue_doorbell_id15" },
		{ 0, NULL },
};

static const struct umr_mqd_fields umr_mqd_compute_vi[] = {
		{ 0, "header" },
		{ 1, "compute_dispatch_initiator" },
		{ 2, "compute_dim_x" },
		{ 3, "compute_dim_y" },
		{ 4, "compute_dim_z" },
		{ 5, "compute_start_x" },
		{ 6, "compute_start_y" },
		{ 7, "compute_start_z" },
		{ 8, "compute_num_thread_x" },
		{ 9, "compute_num_thread_y" },
		{ 10, "compute_num_thread_z" },
		{ 11, "compute_pipelinestat_enable" },
		{ 12, "compute_perfcount_enable" },
		{ 13, "compute_pgm_lo" },
		{ 14, "compute_pgm_hi" },
		{ 15, "compute_tba_lo" },
		{ 16, "compute_tba_hi" },
		{ 17, "compute_tma_lo" },
		{ 18, "compute_tma_hi" },
		{ 19, "compute_pgm_rsrc1" },
		{ 20, "compute_pgm_rsrc2" },
		{ 21, "compute_vmid" },
		{ 22, "compute_resource_limits" },
		{ 23, "compute_static_thread_mgmt_se0" },
		{ 24, "compute_static_thread_mgmt_se1" },
		{ 25, "compute_tmpring_size" },
		{ 26, "compute_static_thread_mgmt_se2" },
		{ 27, "compute_static_thread_mgmt_se3" },
		{ 28, "compute_restart_x" },
		{ 29, "compute_restart_y" },
		{ 30, "compute_restart_z" },
		{ 31, "compute_thread_trace_enable" },
		{ 33, "compute_dispatch_id" },
		{ 34, "compute_threadgroup_id" },
		{ 35, "compute_relaunch" },
		{ 36, "compute_wave_restore_addr_lo" },
		{ 37, "compute_wave_restore_addr_hi" },
		{ 38, "compute_wave_restore_control" },
		{ 39, "compute_static_thread_mgmt_se4" },
		{ 40, "compute_static_thread_mgmt_se5" },
		{ 41, "compute_static_thread_mgmt_se6" },
		{ 42, "compute_static_thread_mgmt_se7" },
		{ 65, "compute_user_data_0" },
		{ 66, "compute_user_data_1" },
		{ 67, "compute_user_data_2" },
		{ 68, "compute_user_data_3" },
		{ 69, "compute_user_data_4" },
		{ 70, "compute_user_data_5" },
		{ 71, "compute_user_data_6" },
		{ 72, "compute_user_data_7" },
		{ 73, "compute_user_data_8" },
		{ 74, "compute_user_data_9" },
		{ 75, "compute_user_data_10" },
		{ 76, "compute_user_data_11" },
		{ 77, "compute_user_data_12" },
		{ 78, "compute_user_data_13" },
		{ 79, "compute_user_data_14" },
		{ 80, "compute_user_data_15" },
		{ 81, "cp_compute_csinvoc_count_lo" },
		{ 82, "cp_compute_csinvoc_count_hi" },
		{ 86, "cp_mqd_query_time_lo" },
		{ 87, "cp_mqd_query_time_hi" },
		{ 88, "cp_mqd_connect_start_time_lo" },
		{ 89, "cp_mqd_connect_start_time_hi" },
		{ 90, "cp_mqd_connect_end_time_lo" },
		{ 91, "cp_mqd_connect_end_time_hi" },
		{ 92, "cp_mqd_connect_end_wf_count" },
		{ 93, "cp_mqd_connect_end_pq_rptr" },
		{ 94, "cp_mqd_connect_end_pq_wptr" },
		{ 95, "cp_mqd_connect_end_ib_rptr" },
		{ 96, "cp_mqd_readindex_lo" },
		{ 97, "cp_mqd_readindex_hi" },
		{ 98, "cp_mqd_save_start_time_lo" },
		{ 99, "cp_mqd_save_start_time_hi" },
		{ 100, "cp_mqd_save_end_time_lo" },
		{ 101, "cp_mqd_save_end_time_hi" },
		{ 102, "cp_mqd_restore_start_time_lo" },
		{ 103, "cp_mqd_restore_start_time_hi" },
		{ 104, "cp_mqd_restore_end_time_lo" },
		{ 105, "cp_mqd_restore_end_time_hi" },
		{ 106, "disable_queue" },
		{ 108, "gds_cs_ctxsw_cnt0" },
		{ 109, "gds_cs_ctxsw_cnt1" },
		{ 110, "gds_cs_ctxsw_cnt2" },
		{ 111, "gds_cs_ctxsw_cnt3" },
		{ 114, "cp_pq_exe_status_lo" },
		{ 115, "cp_pq_exe_status_hi" },
		{ 116, "cp_packet_id_lo" },
		{ 117, "cp_packet_id_hi" },
		{ 118, "cp_packet_exe_status_lo" },
		{ 119, "cp_packet_exe_status_hi" },
		{ 120, "gds_save_base_addr_lo" },
		{ 121, "gds_save_base_addr_hi" },
		{ 122, "gds_save_mask_lo" },
		{ 123, "gds_save_mask_hi" },
		{ 124, "ctx_save_base_addr_lo" },
		{ 125, "ctx_save_base_addr_hi" },
		{ 126, "dynamic_cu_mask_addr_lo" },
		{ 127, "dynamic_cu_mask_addr_hi" },
		{ 128, "cp_mqd_base_addr_lo" },
		{ 129, "cp_mqd_base_addr_hi" },
		{ 130, "cp_hqd_active" },
		{ 131, "cp_hqd_vmid" },
		{ 132, "cp_hqd_persistent_state" },
		{ 133, "cp_hqd_pipe_priority" },
		{ 134, "cp_hqd_queue_priority" },
		{ 135, "cp_hqd_quantum" },
		{ 136, "cp_hqd_pq_base_lo" },
		{ 137, "cp_hqd_pq_base_hi" },
		{ 138, "cp_hqd_pq_rptr" },
		{ 139, "cp_hqd_pq_rptr_report_addr_lo" },
		{ 140, "cp_hqd_pq_rptr_report_addr_hi" },
		{ 141, "cp_hqd_pq_wptr_poll_addr_lo" },
		{ 142, "cp_hqd_pq_wptr_poll_addr_hi" },
		{ 143, "cp_hqd_pq_doorbell_control" },
		{ 145, "cp_hqd_pq_control" },
		{ 146, "cp_hqd_ib_base_addr_lo" },
		{ 147, "cp_hqd_ib_base_addr_hi" },
		{ 148, "cp_hqd_ib_rptr" },
		{ 149, "cp_hqd_ib_control" },
		{ 150, "cp_hqd_iq_timer" },
		{ 151, "cp_hqd_iq_rptr" },
		{ 152, "cp_hqd_dequeue_request" },
		{ 153, "cp_hqd_dma_offload" },
		{ 154, "cp_hqd_sema_cmd" },
		{ 155, "cp_hqd_msg_type" },
		{ 156, "cp_hqd_atomic0_preop_lo" },
		{ 157, "cp_hqd_atomic0_preop_hi" },
		{ 158, "cp_hqd_atomic1_preop_lo" },
		{ 159, "cp_hqd_atomic1_preop_hi" },
		{ 160, "cp_hqd_hq_status0" },
		{ 161, "cp_hqd_hq_control0" },
		{ 162, "cp_mqd_control" },
		{ 163, "cp_hqd_hq_status1" },
		{ 164, "cp_hqd_hq_control1" },
		{ 165, "cp_hqd_eop_base_addr_lo" },
		{ 166, "cp_hqd_eop_base_addr_hi" },
		{ 167, "cp_hqd_eop_control" },
		{ 168, "cp_hqd_eop_rptr" },
		{ 169, "cp_hqd_eop_wptr" },
		{ 170, "cp_hqd_eop_done_events" },
		{ 171, "cp_hqd_ctx_save_base_addr_lo" },
		{ 172, "cp_hqd_ctx_save_base_addr_hi" },
		{ 173, "cp_hqd_ctx_save_control" },
		{ 174, "cp_hqd_cntl_stack_offset" },
		{ 175, "cp_hqd_cntl_stack_size" },
		{ 176, "cp_hqd_wg_state_offset" },
		{ 177, "cp_hqd_ctx_save_size" },
		{ 178, "cp_hqd_gds_resource_state" },
		{ 179, "cp_hqd_error" },
		{ 180, "cp_hqd_eop_wptr_mem" },
		{ 181, "cp_hqd_aql_control" },
		{ 182, "cp_hqd_pq_wptr_lo" },
		{ 183, "cp_hqd_pq_wptr_hi" },
		{ 192, "iqtimer_pkt_header" },
		{ 193, "iqtimer_pkt_dw0" },
		{ 194, "iqtimer_pkt_dw1" },
		{ 195, "iqtimer_pkt_dw2" },
		{ 196, "iqtimer_pkt_dw3" },
		{ 197, "iqtimer_pkt_dw4" },
		{ 198, "iqtimer_pkt_dw5" },
		{ 199, "iqtimer_pkt_dw6" },
		{ 200, "iqtimer_pkt_dw7" },
		{ 201, "iqtimer_pkt_dw8" },
		{ 202, "iqtimer_pkt_dw9" },
		{ 203, "iqtimer_pkt_dw10" },
		{ 204, "iqtimer_pkt_dw11" },
		{ 205, "iqtimer_pkt_dw12" },
		{ 206, "iqtimer_pkt_dw13" },
		{ 207, "iqtimer_pkt_dw14" },
		{ 208, "iqtimer_pkt_dw15" },
		{ 209, "iqtimer_pkt_dw16" },
		{ 210, "iqtimer_pkt_dw17" },
		{ 211, "iqtimer_pkt_dw18" },
		{ 212, "iqtimer_pkt_dw19" },
		{ 213, "iqtimer_pkt_dw20" },
		{ 214, "iqtimer_pkt_dw21" },
		{ 215, "iqtimer_pkt_dw22" },
		{ 216, "iqtimer_pkt_dw23" },
		{ 217, "iqtimer_pkt_dw24" },
		{ 218, "iqtimer_pkt_dw25" },
		{ 219, "iqtimer_pkt_dw26" },
		{ 220, "iqtimer_pkt_dw27" },
		{ 221, "iqtimer_pkt_dw28" },
		{ 222, "iqtimer_pkt_dw29" },
		{ 223, "iqtimer_pkt_dw30" },
		{ 224, "iqtimer_pkt_dw31" },
		{ 228, "set_resources_header" },
		{ 229, "set_resources_dw1" },
		{ 230, "set_resources_dw2" },
		{ 231, "set_resources_dw3" },
		{ 232, "set_resources_dw4" },
		{ 233, "set_resources_dw5" },
		{ 234, "set_resources_dw6" },
		{ 235, "set_resources_dw7" },
		{ 240, "queue_doorbell_id0" },
		{ 241, "queue_doorbell_id1" },
		{ 242, "queue_doorbell_id2" },
		{ 243, "queue_doorbell_id3" },
		{ 244, "queue_doorbell_id4" },
		{ 245, "queue_doorbell_id5" },
		{ 246, "queue_doorbell_id6" },
		{ 247, "queue_doorbell_id7" },
		{ 248, "queue_doorbell_id8" },
		{ 249, "queue_doorbell_id9" },
		{ 250, "queue_doorbell_id10" },
		{ 251, "queue_doorbell_id11" },
		{ 252, "queue_doorbell_id12" },
		{ 253, "queue_doorbell_id13" },
		{ 254, "queue_doorbell_id14" },
		{ 255, "queue_doorbell_id15" },
		{ 0, NULL },
};

static const struct umr_mqd_fields umr_mqd_graphics_nv[] = {
		{ 106, "disable_queue" },
		{ 128, "cp_mqd_base_addr" },
		{ 129, "cp_mqd_base_addr_hi" },
		{ 130, "cp_gfx_hqd_active" },
		{ 131, "cp_gfx_hqd_vmid" },
		{ 134, "cp_gfx_hqd_queue_priority" },
		{ 135, "cp_gfx_hqd_quantum" },
		{ 136, "cp_gfx_hqd_base" },
		{ 137, "cp_gfx_hqd_base_hi" },
		{ 138, "cp_gfx_hqd_rptr" },
		{ 139, "cp_gfx_hqd_rptr_addr" },
		{ 140, "cp_gfx_hqd_rptr_addr_hi" },
		{ 141, "cp_rb_wptr_poll_addr_lo" },
		{ 142, "cp_rb_wptr_poll_addr_hi" },
		{ 143, "cp_rb_doorbell_control" },
		{ 144, "cp_gfx_hqd_offset" },
		{ 145, "cp_gfx_hqd_cntl" },
		{ 148, "cp_gfx_hqd_csmd_rptr" },
		{ 149, "cp_gfx_hqd_wptr" },
		{ 150, "cp_gfx_hqd_wptr_hi" },
		{ 156, "cp_gfx_hqd_mapped" },
		{ 157, "cp_gfx_hqd_que_mgr_control" },
		{ 160, "cp_gfx_hqd_hq_status0" },
		{ 161, "cp_gfx_hqd_hq_control0" },
		{ 162, "cp_gfx_mqd_control" },
		{ 170, "cp_num_prim_needed_count0_lo" },
		{ 171, "cp_num_prim_needed_count0_hi" },
		{ 172, "cp_num_prim_needed_count1_lo" },
		{ 173, "cp_num_prim_needed_count1_hi" },
		{ 174, "cp_num_prim_needed_count2_lo" },
		{ 175, "cp_num_prim_needed_count2_hi" },
		{ 176, "cp_num_prim_needed_count3_lo" },
		{ 177, "cp_num_prim_needed_count3_hi" },
		{ 178, "cp_num_prim_written_count0_lo" },
		{ 179, "cp_num_prim_written_count0_hi" },
		{ 180, "cp_num_prim_written_count1_lo" },
		{ 181, "cp_num_prim_written_count1_hi" },
		{ 182, "cp_num_prim_written_count2_lo" },
		{ 183, "cp_num_prim_written_count2_hi" },
		{ 184, "cp_num_prim_written_count3_lo" },
		{ 185, "cp_num_prim_written_count3_hi" },
		{ 190, "mp1_smn_fps_cnt" },
		{ 191, "sq_thread_trace_buf0_base" },
		{ 192, "sq_thread_trace_buf0_size" },
		{ 193, "sq_thread_trace_buf1_base" },
		{ 194, "sq_thread_trace_buf1_size" },
		{ 195, "sq_thread_trace_wptr" },
		{ 196, "sq_thread_trace_mask" },
		{ 197, "sq_thread_trace_token_mask" },
		{ 198, "sq_thread_trace_ctrl" },
		{ 199, "sq_thread_trace_status" },
		{ 200, "sq_thread_trace_dropped_cntr" },
		{ 201, "sq_thread_trace_finish_done_debug" },
		{ 202, "sq_thread_trace_gfx_draw_cntr" },
		{ 203, "sq_thread_trace_gfx_marker_cntr" },
		{ 204, "sq_thread_trace_hp3d_draw_cntr" },
		{ 205, "sq_thread_trace_hp3d_marker_cntr" },
		{ 208, "cp_sc_psinvoc_count0_lo" },
		{ 209, "cp_sc_psinvoc_count0_hi" },
		{ 210, "cp_pa_cprim_count_lo" },
		{ 211, "cp_pa_cprim_count_hi" },
		{ 212, "cp_pa_cinvoc_count_lo" },
		{ 213, "cp_pa_cinvoc_count_hi" },
		{ 214, "cp_vgt_vsinvoc_count_lo" },
		{ 215, "cp_vgt_vsinvoc_count_hi" },
		{ 216, "cp_vgt_gsinvoc_count_lo" },
		{ 217, "cp_vgt_gsinvoc_count_hi" },
		{ 218, "cp_vgt_gsprim_count_lo" },
		{ 219, "cp_vgt_gsprim_count_hi" },
		{ 220, "cp_vgt_iaprim_count_lo" },
		{ 221, "cp_vgt_iaprim_count_hi" },
		{ 222, "cp_vgt_iavert_count_lo" },
		{ 223, "cp_vgt_iavert_count_hi" },
		{ 224, "cp_vgt_hsinvoc_count_lo" },
		{ 225, "cp_vgt_hsinvoc_count_hi" },
		{ 226, "cp_vgt_dsinvoc_count_lo" },
		{ 227, "cp_vgt_dsinvoc_count_hi" },
		{ 228, "cp_vgt_csinvoc_count_lo" },
		{ 229, "cp_vgt_csinvoc_count_hi" },
		{ 268, "vgt_strmout_buffer_filled_size_0" },
		{ 269, "vgt_strmout_buffer_filled_size_1" },
		{ 270, "vgt_strmout_buffer_filled_size_2" },
		{ 271, "vgt_strmout_buffer_filled_size_3" },
		{ 276, "vgt_dma_max_size" },
		{ 277, "vgt_dma_num_instances" },
		{ 288, "it_set_base_ib_addr_lo" },
		{ 289, "it_set_base_ib_addr_hi" },
		{ 356, "spi_shader_pgm_rsrc3_ps" },
		{ 357, "spi_shader_pgm_rsrc3_vs" },
		{ 358, "spi_shader_pgm_rsrc3_gs" },
		{ 359, "spi_shader_pgm_rsrc3_hs" },
		{ 360, "spi_shader_pgm_rsrc4_ps" },
		{ 361, "spi_shader_pgm_rsrc4_vs" },
		{ 362, "spi_shader_pgm_rsrc4_gs" },
		{ 363, "spi_shader_pgm_rsrc4_hs" },
		{ 364, "db_occlusion_count0_low_00" },
		{ 365, "db_occlusion_count0_hi_00" },
		{ 366, "db_occlusion_count1_low_00" },
		{ 367, "db_occlusion_count1_hi_00" },
		{ 368, "db_occlusion_count2_low_00" },
		{ 369, "db_occlusion_count2_hi_00" },
		{ 370, "db_occlusion_count3_low_00" },
		{ 371, "db_occlusion_count3_hi_00" },
		{ 372, "db_occlusion_count0_low_01" },
		{ 373, "db_occlusion_count0_hi_01" },
		{ 374, "db_occlusion_count1_low_01" },
		{ 375, "db_occlusion_count1_hi_01" },
		{ 376, "db_occlusion_count2_low_01" },
		{ 377, "db_occlusion_count2_hi_01" },
		{ 378, "db_occlusion_count3_low_01" },
		{ 379, "db_occlusion_count3_hi_01" },
		{ 380, "db_occlusion_count0_low_02" },
		{ 381, "db_occlusion_count0_hi_02" },
		{ 382, "db_occlusion_count1_low_02" },
		{ 383, "db_occlusion_count1_hi_02" },
		{ 384, "db_occlusion_count2_low_02" },
		{ 385, "db_occlusion_count2_hi_02" },
		{ 386, "db_occlusion_count3_low_02" },
		{ 387, "db_occlusion_count3_hi_02" },
		{ 388, "db_occlusion_count0_low_03" },
		{ 389, "db_occlusion_count0_hi_03" },
		{ 390, "db_occlusion_count1_low_03" },
		{ 391, "db_occlusion_count1_hi_03" },
		{ 392, "db_occlusion_count2_low_03" },
		{ 393, "db_occlusion_count2_hi_03" },
		{ 394, "db_occlusion_count3_low_03" },
		{ 395, "db_occlusion_count3_hi_03" },
		{ 396, "db_occlusion_count0_low_04" },
		{ 397, "db_occlusion_count0_hi_04" },
		{ 398, "db_occlusion_count1_low_04" },
		{ 399, "db_occlusion_count1_hi_04" },
		{ 400, "db_occlusion_count2_low_04" },
		{ 401, "db_occlusion_count2_hi_04" },
		{ 402, "db_occlusion_count3_low_04" },
		{ 403, "db_occlusion_count3_hi_04" },
		{ 404, "db_occlusion_count0_low_05" },
		{ 405, "db_occlusion_count0_hi_05" },
		{ 406, "db_occlusion_count1_low_05" },
		{ 407, "db_occlusion_count1_hi_05" },
		{ 408, "db_occlusion_count2_low_05" },
		{ 409, "db_occlusion_count2_hi_05" },
		{ 410, "db_occlusion_count3_low_05" },
		{ 411, "db_occlusion_count3_hi_05" },
		{ 412, "db_occlusion_count0_low_06" },
		{ 413, "db_occlusion_count0_hi_06" },
		{ 414, "db_occlusion_count1_low_06" },
		{ 415, "db_occlusion_count1_hi_06" },
		{ 416, "db_occlusion_count2_low_06" },
		{ 417, "db_occlusion_count2_hi_06" },
		{ 418, "db_occlusion_count3_low_06" },
		{ 419, "db_occlusion_count3_hi_06" },
		{ 420, "db_occlusion_count0_low_07" },
		{ 421, "db_occlusion_count0_hi_07" },
		{ 422, "db_occlusion_count1_low_07" },
		{ 423, "db_occlusion_count1_hi_07" },
		{ 424, "db_occlusion_count2_low_07" },
		{ 425, "db_occlusion_count2_hi_07" },
		{ 426, "db_occlusion_count3_low_07" },
		{ 427, "db_occlusion_count3_hi_07" },
		{ 428, "db_occlusion_count0_low_10" },
		{ 429, "db_occlusion_count0_hi_10" },
		{ 430, "db_occlusion_count1_low_10" },
		{ 431, "db_occlusion_count1_hi_10" },
		{ 432, "db_occlusion_count2_low_10" },
		{ 433, "db_occlusion_count2_hi_10" },
		{ 434, "db_occlusion_count3_low_10" },
		{ 435, "db_occlusion_count3_hi_10" },
		{ 436, "db_occlusion_count0_low_11" },
		{ 437, "db_occlusion_count0_hi_11" },
		{ 438, "db_occlusion_count1_low_11" },
		{ 439, "db_occlusion_count1_hi_11" },
		{ 440, "db_occlusion_count2_low_11" },
		{ 441, "db_occlusion_count2_hi_11" },
		{ 442, "db_occlusion_count3_low_11" },
		{ 443, "db_occlusion_count3_hi_11" },
		{ 444, "db_occlusion_count0_low_12" },
		{ 445, "db_occlusion_count0_hi_12" },
		{ 446, "db_occlusion_count1_low_12" },
		{ 447, "db_occlusion_count1_hi_12" },
		{ 448, "db_occlusion_count2_low_12" },
		{ 449, "db_occlusion_count2_hi_12" },
		{ 450, "db_occlusion_count3_low_12" },
		{ 451, "db_occlusion_count3_hi_12" },
		{ 452, "db_occlusion_count0_low_13" },
		{ 453, "db_occlusion_count0_hi_13" },
		{ 454, "db_occlusion_count1_low_13" },
		{ 455, "db_occlusion_count1_hi_13" },
		{ 456, "db_occlusion_count2_low_13" },
		{ 457, "db_occlusion_count2_hi_13" },
		{ 458, "db_occlusion_count3_low_13" },
		{ 459, "db_occlusion_count3_hi_13" },
		{ 460, "db_occlusion_count0_low_14" },
		{ 461, "db_occlusion_count0_hi_14" },
		{ 462, "db_occlusion_count1_low_14" },
		{ 463, "db_occlusion_count1_hi_14" },
		{ 464, "db_occlusion_count2_low_14" },
		{ 465, "db_occlusion_count2_hi_14" },
		{ 466, "db_occlusion_count3_low_14" },
		{ 467, "db_occlusion_count3_hi_14" },
		{ 468, "db_occlusion_count0_low_15" },
		{ 469, "db_occlusion_count0_hi_15" },
		{ 470, "db_occlusion_count1_low_15" },
		{ 471, "db_occlusion_count1_hi_15" },
		{ 472, "db_occlusion_count2_low_15" },
		{ 473, "db_occlusion_count2_hi_15" },
		{ 474, "db_occlusion_count3_low_15" },
		{ 475, "db_occlusion_count3_hi_15" },
		{ 476, "db_occlusion_count0_low_16" },
		{ 477, "db_occlusion_count0_hi_16" },
		{ 478, "db_occlusion_count1_low_16" },
		{ 479, "db_occlusion_count1_hi_16" },
		{ 480, "db_occlusion_count2_low_16" },
		{ 481, "db_occlusion_count2_hi_16" },
		{ 482, "db_occlusion_count3_low_16" },
		{ 483, "db_occlusion_count3_hi_16" },
		{ 484, "db_occlusion_count0_low_17" },
		{ 485, "db_occlusion_count0_hi_17" },
		{ 486, "db_occlusion_count1_low_17" },
		{ 487, "db_occlusion_count1_hi_17" },
		{ 488, "db_occlusion_count2_low_17" },
		{ 489, "db_occlusion_count2_hi_17" },
		{ 490, "db_occlusion_count3_low_17" },
		{ 491, "db_occlusion_count3_hi_17" },
		{ 0, NULL },
};

static const struct umr_mqd_fields umr_mqd_sdma_nv[] = {
		{ 0, "sdmax_rlcx_rb_cntl" },
		{ 1, "sdmax_rlcx_rb_base" },
		{ 2, "sdmax_rlcx_rb_base_hi" },
		{ 3, "sdmax_rlcx_rb_rptr" },
		{ 4, "sdmax_rlcx_rb_rptr_hi" },
		{ 5, "sdmax_rlcx_rb_wptr" },
		{ 6, "sdmax_rlcx_rb_wptr_hi" },
		{ 7, "sdmax_rlcx_rb_wptr_poll_cntl" },
		{ 8, "sdmax_rlcx_rb_rptr_addr_hi" },
		{ 9, "sdmax_rlcx_rb_rptr_addr_lo" },
		{ 10, "sdmax_rlcx_ib_cntl" },
		{ 11, "sdmax_rlcx_ib_rptr" },
		{ 12, "sdmax_rlcx_ib_offset" },
		{ 13, "sdmax_rlcx_ib_base_lo" },
		{ 14, "sdmax_rlcx_ib_base_hi" },
		{ 15, "sdmax_rlcx_ib_size" },
		{ 16, "sdmax_rlcx_skip_cntl" },
		{ 17, "sdmax_rlcx_context_status" },
		{ 18, "sdmax_rlcx_doorbell" },
		{ 19, "sdmax_rlcx_status" },
		{ 20, "sdmax_rlcx_doorbell_log" },
		{ 21, "sdmax_rlcx_watermark" },
		{ 22, "sdmax_rlcx_doorbell_offset" },
		{ 23, "sdmax_rlcx_csa_addr_lo" },
		{ 24, "sdmax_rlcx_csa_addr_hi" },
		{ 25, "sdmax_rlcx_ib_sub_remain" },
		{ 26, "sdmax_rlcx_preempt" },
		{ 27, "sdmax_rlcx_dummy_reg" },
		{ 28, "sdmax_rlcx_rb_wptr_poll_addr_hi" },
		{ 29, "sdmax_rlcx_rb_wptr_poll_addr_lo" },
		{ 30, "sdmax_rlcx_rb_aql_cntl" },
		{ 31, "sdmax_rlcx_minor_ptr_update" },
		{ 32, "sdmax_rlcx_midcmd_data0" },
		{ 33, "sdmax_rlcx_midcmd_data1" },
		{ 34, "sdmax_rlcx_midcmd_data2" },
		{ 35, "sdmax_rlcx_midcmd_data3" },
		{ 36, "sdmax_rlcx_midcmd_data4" },
		{ 37, "sdmax_rlcx_midcmd_data5" },
		{ 38, "sdmax_rlcx_midcmd_data6" },
		{ 39, "sdmax_rlcx_midcmd_data7" },
		{ 40, "sdmax_rlcx_midcmd_data8" },
		{ 41, "sdmax_rlcx_midcmd_cntl" },
		{ 128, "sdma_engine_id" },
		{ 129, "sdma_queue_id" },
		{ 0, NULL },
};	

static const struct umr_mqd_fields umr_mqd_sdma_vi[] = {
		{ 0, "sdmax_rlcx_rb_cntl" },
		{ 1, "sdmax_rlcx_rb_base" },
		{ 2, "sdmax_rlcx_rb_base_hi" },
		{ 3, "sdmax_rlcx_rb_rptr" },
		{ 4, "sdmax_rlcx_rb_rptr_hi" },
		{ 5, "sdmax_rlcx_rb_wptr" },
		{ 6, "sdmax_rlcx_rb_wptr_hi" },
		{ 7, "sdmax_rlcx_rb_wptr_poll_cntl" },
		{ 8, "sdmax_rlcx_rb_rptr_addr_hi" },
		{ 9, "sdmax_rlcx_rb_rptr_addr_lo" },
		{ 10, "sdmax_rlcx_ib_cntl" },
		{ 11, "sdmax_rlcx_ib_rptr" },
		{ 12, "sdmax_rlcx_ib_offset" },
		{ 13, "sdmax_rlcx_ib_base_lo" },
		{ 14, "sdmax_rlcx_ib_base_hi" },
		{ 15, "sdmax_rlcx_ib_size" },
		{ 16, "sdmax_rlcx_skip_cntl" },
		{ 17, "sdmax_rlcx_context_status" },
		{ 18, "sdmax_rlcx_doorbell" },
		{ 19, "sdmax_rlcx_status" },
		{ 20, "sdmax_rlcx_doorbell_log" },
		{ 21, "sdmax_rlcx_watermark" },
		{ 22, "sdmax_rlcx_doorbell_offset" },
		{ 23, "sdmax_rlcx_csa_addr_lo" },
		{ 24, "sdmax_rlcx_csa_addr_hi" },
		{ 25, "sdmax_rlcx_ib_sub_remain" },
		{ 26, "sdmax_rlcx_preempt" },
		{ 27, "sdmax_rlcx_dummy_reg" },
		{ 28, "sdmax_rlcx_rb_wptr_poll_addr_hi" },
		{ 29, "sdmax_rlcx_rb_wptr_poll_addr_lo" },
		{ 30, "sdmax_rlcx_rb_aql_cntl" },
		{ 31, "sdmax_rlcx_minor_ptr_update" },
		{ 32, "sdmax_rlcx_midcmd_data0" },
		{ 33, "sdmax_rlcx_midcmd_data1" },
		{ 34, "sdmax_rlcx_midcmd_data2" },
		{ 35, "sdmax_rlcx_midcmd_data3" },
		{ 36, "sdmax_rlcx_midcmd_data4" },
		{ 37, "sdmax_rlcx_midcmd_data5" },
		{ 38, "sdmax_rlcx_midcmd_data6" },
		{ 39, "sdmax_rlcx_midcmd_data7" },
		{ 40, "sdmax_rlcx_midcmd_data8" },
		{ 41, "sdmax_rlcx_midcmd_cntl" },
		{ 126, "sdma_engine_id" },
		{ 127, "sdma_queue_id" },
};

static const struct {
	enum umr_mqd_engine_sel eng;
	enum chipfamily family;
	const struct umr_mqd_fields *fields;
} fields[] = {
	// sort by highest family on top
	{ UMR_MQD_ENGINE_MES,     FAMILY_GFX12, umr_mqd_compute_gfx12  },
	{ UMR_MQD_ENGINE_COMPUTE, FAMILY_GFX12, umr_mqd_compute_gfx12  },
	{ UMR_MQD_ENGINE_GFX,     FAMILY_GFX12, umr_mqd_graphics_gfx12 },
	{ UMR_MQD_ENGINE_SDMA0,   FAMILY_GFX12, umr_mqd_sdma_gfx12 },
	{ UMR_MQD_ENGINE_MES,     FAMILY_GFX11, umr_mqd_compute_gfx11  },
	{ UMR_MQD_ENGINE_COMPUTE, FAMILY_GFX11, umr_mqd_compute_gfx11  },
	{ UMR_MQD_ENGINE_GFX,     FAMILY_GFX11, umr_mqd_graphics_gfx11 },
	{ UMR_MQD_ENGINE_SDMA0,   FAMILY_GFX11, umr_mqd_sdma_gfx11 },
	{ UMR_MQD_ENGINE_GFX,     FAMILY_NV,    umr_mqd_graphics_nv },
	{ UMR_MQD_ENGINE_COMPUTE, FAMILY_NV,    umr_mqd_compute_nv },
	{ UMR_MQD_ENGINE_SDMA0,   FAMILY_NV,    umr_mqd_sdma_nv },
	{ UMR_MQD_ENGINE_COMPUTE, FAMILY_VI,    umr_mqd_compute_vi },
	{ UMR_MQD_ENGINE_SDMA0,   FAMILY_VI,    umr_mqd_sdma_vi },
	{ 0, 0, NULL }
};

// size of MQD data in words
uint32_t umr_mqd_decode_size(enum umr_mqd_engine_sel eng, enum chipfamily fam)
{
	const struct umr_mqd_fields *m;
	uint32_t x, y, z;

	for (x = 0; fields[x].fields != NULL; x++) {
		if (eng == fields[x].eng && fam >= fields[x].family) {
			m = fields[x].fields;
			for (y = z = 0; m[y].label; y++) {
				if (m[y].offset > z) {
					z = m[y].offset;
				}
			}
			return z + 1;
		}
	}
	return 0;
}

// number of variables in MQD
uint32_t umr_mqd_decode_rows(enum umr_mqd_engine_sel eng, enum chipfamily fam)
{
	const struct umr_mqd_fields *m;
	uint32_t x, y, z;

	for (x = 0; fields[x].fields != NULL; x++) {
		if (eng == fields[x].eng && fam >= fields[x].family) {
			m = fields[x].fields;
			for (y = z = 0; m[y].label; y++) {
				++z;
			}
			return z;
		}
	}
	return 0;
}

char **umr_mqd_decode_data(enum umr_mqd_engine_sel eng, enum chipfamily fam, uint32_t *data, char *match)
{
	const struct umr_mqd_fields *m;
	uint32_t x, y, z;
	char **txt;
	char buf[256];
	
	y = umr_mqd_decode_rows(eng, fam);
	if (!y) {
		return NULL;
	}
	txt = calloc(y + 1, sizeof(*txt));
	for (x = 0; fields[x].fields != NULL; x++) {
		if (eng == fields[x].eng && fam >= fields[x].family) {
			m = fields[x].fields;
			for (y = z = 0; m[y].label; y++) {
				if (match[0] == '*' || strstr(m[y].label, match)) {
					sprintf(buf, "MQD[%"PRIu32"] == 0x%"PRIx32" (%s)", m[y].offset, data[m[y].offset], m[y].label);
					txt[z++] = strdup(buf);
				}
			}
			return txt;
		}
	}
	free(txt);
	return NULL;
}
